//line php5/php5.y:2
package php5

import __yyfmt__ "fmt"

//line php5/php5.y:2
import (
	//    "fmt"
	//    "strings"
	"strconv"

	"github.com/z7zmey/php-parser/node"
	"github.com/z7zmey/php-parser/node/expr"
	"github.com/z7zmey/php-parser/node/name"
	"github.com/z7zmey/php-parser/node/scalar"
	"github.com/z7zmey/php-parser/node/stmt"
	"github.com/z7zmey/php-parser/token"

//    "github.com/z7zmey/php-parser/node/expr/assign_op"
//    "github.com/z7zmey/php-parser/node/expr/binary_op"
//    "github.com/z7zmey/php-parser/node/expr/cast"
)

//line php5/php5.y:22
type yySymType struct {
	yys   int
	node  node.Node
	token token.Token
	//    boolWithToken boolWithToken
	list []node.Node
	//    foreachVariable foreachVariable
	//    nodesWithEndToken *nodesWithEndToken
	simpleIndirectReference simpleIndirectReference
	//    str string
}

const T_INCLUDE = 57346
const T_INCLUDE_ONCE = 57347
const T_EXIT = 57348
const T_IF = 57349
const T_LNUMBER = 57350
const T_DNUMBER = 57351
const T_STRING = 57352
const T_STRING_VARNAME = 57353
const T_VARIABLE = 57354
const T_NUM_STRING = 57355
const T_INLINE_HTML = 57356
const T_CHARACTER = 57357
const T_BAD_CHARACTER = 57358
const T_ENCAPSED_AND_WHITESPACE = 57359
const T_CONSTANT_ENCAPSED_STRING = 57360
const T_ECHO = 57361
const T_DO = 57362
const T_WHILE = 57363
const T_ENDWHILE = 57364
const T_FOR = 57365
const T_ENDFOR = 57366
const T_FOREACH = 57367
const T_ENDFOREACH = 57368
const T_DECLARE = 57369
const T_ENDDECLARE = 57370
const T_AS = 57371
const T_SWITCH = 57372
const T_ENDSWITCH = 57373
const T_CASE = 57374
const T_DEFAULT = 57375
const T_BREAK = 57376
const T_CONTINUE = 57377
const T_GOTO = 57378
const T_FUNCTION = 57379
const T_CONST = 57380
const T_RETURN = 57381
const T_TRY = 57382
const T_CATCH = 57383
const T_FINALLY = 57384
const T_THROW = 57385
const T_USE = 57386
const T_INSTEADOF = 57387
const T_GLOBAL = 57388
const T_VAR = 57389
const T_UNSET = 57390
const T_ISSET = 57391
const T_EMPTY = 57392
const T_HALT_COMPILER = 57393
const T_CLASS = 57394
const T_TRAIT = 57395
const T_INTERFACE = 57396
const T_EXTENDS = 57397
const T_IMPLEMENTS = 57398
const T_OBJECT_OPERATOR = 57399
const T_DOUBLE_ARROW = 57400
const T_LIST = 57401
const T_ARRAY = 57402
const T_CALLABLE = 57403
const T_CLASS_C = 57404
const T_TRAIT_C = 57405
const T_METHOD_C = 57406
const T_FUNC_C = 57407
const T_LINE = 57408
const T_FILE = 57409
const T_COMMENT = 57410
const T_DOC_COMMENT = 57411
const T_OPEN_TAG = 57412
const T_OPEN_TAG_WITH_ECHO = 57413
const T_CLOSE_TAG = 57414
const T_WHITESPACE = 57415
const T_START_HEREDOC = 57416
const T_END_HEREDOC = 57417
const T_DOLLAR_OPEN_CURLY_BRACES = 57418
const T_CURLY_OPEN = 57419
const T_PAAMAYIM_NEKUDOTAYIM = 57420
const T_NAMESPACE = 57421
const T_NS_C = 57422
const T_DIR = 57423
const T_NS_SEPARATOR = 57424
const T_ELLIPSIS = 57425
const T_EVAL = 57426
const T_REQUIRE = 57427
const T_REQUIRE_ONCE = 57428
const T_LOGICAL_OR = 57429
const T_LOGICAL_XOR = 57430
const T_LOGICAL_AND = 57431
const T_INSTANCEOF = 57432
const T_NEW = 57433
const T_CLONE = 57434
const T_ELSEIF = 57435
const T_ELSE = 57436
const T_ENDIF = 57437
const T_PRINT = 57438
const T_YIELD = 57439
const T_STATIC = 57440
const T_ABSTRACT = 57441
const T_FINAL = 57442
const T_PRIVATE = 57443
const T_PROTECTED = 57444
const T_PUBLIC = 57445
const T_INC = 57446
const T_DEC = 57447
const T_YIELD_FROM = 57448
const T_INT_CAST = 57449
const T_DOUBLE_CAST = 57450
const T_STRING_CAST = 57451
const T_ARRAY_CAST = 57452
const T_OBJECT_CAST = 57453
const T_BOOL_CAST = 57454
const T_UNSET_CAST = 57455
const T_COALESCE = 57456
const T_SPACESHIP = 57457
const T_NOELSE = 57458
const T_PLUS_EQUAL = 57459
const T_MINUS_EQUAL = 57460
const T_MUL_EQUAL = 57461
const T_DIV_EQUAL = 57462
const T_CONCAT_EQUAL = 57463
const T_MOD_EQUAL = 57464
const T_AND_EQUAL = 57465
const T_OR_EQUAL = 57466
const T_XOR_EQUAL = 57467
const T_SL_EQUAL = 57468
const T_SR_EQUAL = 57469
const T_POW_EQUAL = 57470
const T_BOOLEAN_OR = 57471
const T_BOOLEAN_AND = 57472
const T_IS_EQUAL = 57473
const T_IS_NOT_EQUAL = 57474
const T_IS_IDENTICAL = 57475
const T_IS_NOT_IDENTICAL = 57476
const T_IS_SMALLER_OR_EQUAL = 57477
const T_IS_GREATER_OR_EQUAL = 57478
const T_SL = 57479
const T_SR = 57480
const T_POW = 57481

var yyToknames = [...]string{
	"$end",
	"error",
	"$unk",
	"T_INCLUDE",
	"T_INCLUDE_ONCE",
	"T_EXIT",
	"T_IF",
	"T_LNUMBER",
	"T_DNUMBER",
	"T_STRING",
	"T_STRING_VARNAME",
	"T_VARIABLE",
	"T_NUM_STRING",
	"T_INLINE_HTML",
	"T_CHARACTER",
	"T_BAD_CHARACTER",
	"T_ENCAPSED_AND_WHITESPACE",
	"T_CONSTANT_ENCAPSED_STRING",
	"T_ECHO",
	"T_DO",
	"T_WHILE",
	"T_ENDWHILE",
	"T_FOR",
	"T_ENDFOR",
	"T_FOREACH",
	"T_ENDFOREACH",
	"T_DECLARE",
	"T_ENDDECLARE",
	"T_AS",
	"T_SWITCH",
	"T_ENDSWITCH",
	"T_CASE",
	"T_DEFAULT",
	"T_BREAK",
	"T_CONTINUE",
	"T_GOTO",
	"T_FUNCTION",
	"T_CONST",
	"T_RETURN",
	"T_TRY",
	"T_CATCH",
	"T_FINALLY",
	"T_THROW",
	"T_USE",
	"T_INSTEADOF",
	"T_GLOBAL",
	"T_VAR",
	"T_UNSET",
	"T_ISSET",
	"T_EMPTY",
	"T_HALT_COMPILER",
	"T_CLASS",
	"T_TRAIT",
	"T_INTERFACE",
	"T_EXTENDS",
	"T_IMPLEMENTS",
	"T_OBJECT_OPERATOR",
	"T_DOUBLE_ARROW",
	"T_LIST",
	"T_ARRAY",
	"T_CALLABLE",
	"T_CLASS_C",
	"T_TRAIT_C",
	"T_METHOD_C",
	"T_FUNC_C",
	"T_LINE",
	"T_FILE",
	"T_COMMENT",
	"T_DOC_COMMENT",
	"T_OPEN_TAG",
	"T_OPEN_TAG_WITH_ECHO",
	"T_CLOSE_TAG",
	"T_WHITESPACE",
	"T_START_HEREDOC",
	"T_END_HEREDOC",
	"T_DOLLAR_OPEN_CURLY_BRACES",
	"T_CURLY_OPEN",
	"T_PAAMAYIM_NEKUDOTAYIM",
	"T_NAMESPACE",
	"T_NS_C",
	"T_DIR",
	"T_NS_SEPARATOR",
	"T_ELLIPSIS",
	"T_EVAL",
	"T_REQUIRE",
	"T_REQUIRE_ONCE",
	"T_LOGICAL_OR",
	"T_LOGICAL_XOR",
	"T_LOGICAL_AND",
	"T_INSTANCEOF",
	"T_NEW",
	"T_CLONE",
	"T_ELSEIF",
	"T_ELSE",
	"T_ENDIF",
	"T_PRINT",
	"T_YIELD",
	"T_STATIC",
	"T_ABSTRACT",
	"T_FINAL",
	"T_PRIVATE",
	"T_PROTECTED",
	"T_PUBLIC",
	"T_INC",
	"T_DEC",
	"T_YIELD_FROM",
	"T_INT_CAST",
	"T_DOUBLE_CAST",
	"T_STRING_CAST",
	"T_ARRAY_CAST",
	"T_OBJECT_CAST",
	"T_BOOL_CAST",
	"T_UNSET_CAST",
	"T_COALESCE",
	"T_SPACESHIP",
	"T_NOELSE",
	"'\"'",
	"'`'",
	"'{'",
	"'}'",
	"';'",
	"':'",
	"'('",
	"')'",
	"'['",
	"']'",
	"'?'",
	"'&'",
	"'-'",
	"'+'",
	"'!'",
	"'~'",
	"'@'",
	"'$'",
	"','",
	"'='",
	"T_PLUS_EQUAL",
	"T_MINUS_EQUAL",
	"T_MUL_EQUAL",
	"T_DIV_EQUAL",
	"T_CONCAT_EQUAL",
	"T_MOD_EQUAL",
	"T_AND_EQUAL",
	"T_OR_EQUAL",
	"T_XOR_EQUAL",
	"T_SL_EQUAL",
	"T_SR_EQUAL",
	"T_POW_EQUAL",
	"T_BOOLEAN_OR",
	"T_BOOLEAN_AND",
	"'|'",
	"'^'",
	"T_IS_EQUAL",
	"T_IS_NOT_EQUAL",
	"T_IS_IDENTICAL",
	"T_IS_NOT_IDENTICAL",
	"'<'",
	"T_IS_SMALLER_OR_EQUAL",
	"'>'",
	"T_IS_GREATER_OR_EQUAL",
	"T_SL",
	"T_SR",
	"'.'",
	"'*'",
	"'/'",
	"'%'",
	"T_POW",
}
var yyStatenames = [...]string{}

const yyEofCode = 1
const yyErrCode = 2
const yyInitialStackSize = 16

//line php5/php5.y:1954

//line yacctab:1
var yyExca = [...]int{
	-1, 1,
	1, -1,
	-2, 0,
	-1, 50,
	104, 489,
	105, 489,
	-2, 487,
	-1, 101,
	78, 384,
	123, 367,
	-2, 465,
	-1, 113,
	78, 507,
	123, 503,
	-2, 513,
	-1, 153,
	104, 489,
	105, 489,
	-2, 487,
	-1, 203,
	121, 350,
	124, 350,
	-2, 484,
	-1, 204,
	104, 489,
	105, 489,
	121, 351,
	124, 351,
	-2, 487,
	-1, 227,
	123, 367,
	-2, 384,
	-1, 270,
	78, 507,
	-2, 513,
	-1, 296,
	78, 386,
	123, 371,
	-2, 467,
	-1, 300,
	123, 504,
	-2, 514,
	-1, 309,
	78, 385,
	123, 369,
	-2, 466,
	-1, 371,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 311,
	-1, 372,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 312,
	-1, 373,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 313,
	-1, 374,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 314,
	-1, 375,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 315,
	-1, 376,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 316,
	-1, 377,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 317,
	-1, 378,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 318,
	-1, 385,
	104, 489,
	105, 489,
	-2, 487,
	-1, 416,
	123, 371,
	-2, 386,
	-1, 436,
	123, 498,
	-2, 502,
	-1, 453,
	104, 489,
	105, 489,
	124, 571,
	135, 571,
	-2, 487,
	-1, 454,
	124, 572,
	135, 572,
	-2, 484,
	-1, 455,
	104, 489,
	105, 489,
	-2, 487,
	-1, 477,
	123, 375,
	-2, 505,
	-1, 478,
	123, 528,
	-2, 573,
	-1, 483,
	123, 379,
	-2, 506,
	-1, 484,
	123, 528,
	-2, 574,
	-1, 507,
	78, 384,
	-2, 423,
	-1, 553,
	124, 168,
	-2, 173,
	-1, 561,
	121, 352,
	124, 352,
	-2, 484,
	-1, 562,
	104, 489,
	105, 489,
	121, 353,
	124, 353,
	-2, 487,
	-1, 568,
	123, 369,
	-2, 385,
	-1, 569,
	57, 260,
	125, 260,
	-2, 259,
	-1, 612,
	124, 182,
	135, 182,
	-2, 484,
	-1, 613,
	104, 489,
	105, 489,
	124, 183,
	135, 183,
	-2, 487,
	-1, 662,
	78, 386,
	-2, 425,
	-1, 689,
	124, 168,
	-2, 173,
	-1, 704,
	124, 168,
	-2, 173,
	-1, 768,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 451,
	-1, 769,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 452,
	-1, 770,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 453,
	-1, 771,
	153, 0,
	154, 0,
	155, 0,
	156, 0,
	-2, 454,
	-1, 772,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 455,
	-1, 773,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 456,
	-1, 774,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 457,
	-1, 775,
	157, 0,
	158, 0,
	159, 0,
	160, 0,
	-2, 458,
	-1, 778,
	78, 385,
	-2, 424,
	-1, 829,
	57, 255,
	-2, 257,
	-1, 887,
	37, 229,
	-2, 226,
	-1, 949,
	123, 498,
	-2, 502,
	-1, 1015,
	29, 217,
	-2, 4,
	-1, 1041,
	124, 168,
	-2, 173,
	-1, 1045,
	121, 221,
	-2, 223,
}

const yyPrivate = 57344

const yyLast = 8286

var yyAct = [...]int{

	101, 705, 1009, 1066, 891, 114, 136, 113, 711, 122,
	130, 580, 436, 830, 832, 50, 199, 334, 411, 117,
	875, 858, 588, 924, 43, 707, 60, 694, 326, 823,
	611, 4, 424, 717, 803, 465, 664, 452, 383, 317,
	153, 412, 683, 25, 137, 313, 157, 2, 142, 152,
	503, 97, 129, 263, 288, 227, 227, 204, 439, 634,
	178, 328, 468, 478, 6, 120, 203, 1040, 42, 327,
	226, 226, 5, 168, 170, 169, 191, 442, 1003, 120,
	266, 191, 191, 257, 980, 271, 979, 270, 1002, 484,
	1000, 120, 976, 971, 871, 939, 720, 701, 250, 146,
	978, 638, 38, 296, 1001, 479, 240, 860, 859, 940,
	496, 688, 996, 192, 172, 176, 175, 502, 351, 962,
	176, 175, 300, 997, 497, 309, 323, 161, 314, 318,
	566, 269, 321, 1051, 824, 166, 167, 171, 173, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 174, 177, 179, 180, 178, 178,
	227, 818, 900, 339, 191, 634, 332, 782, 739, 333,
	699, 308, 443, 566, 120, 347, 529, 466, 350, 740,
	120, 700, 240, 200, 158, 634, 443, 119, 1021, 636,
	635, 589, 266, 969, 227, 981, 948, 271, 443, 270,
	594, 119, 901, 388, 637, 639, 640, 638, 908, 384,
	385, 595, 125, 119, 120, 907, 634, 729, 565, 386,
	636, 635, 227, 646, 637, 639, 640, 638, 345, 566,
	416, 545, 492, 1070, 838, 780, 38, 413, 177, 179,
	180, 178, 546, 269, 725, 379, 493, 161, 656, 658,
	657, 659, 644, 645, 646, 637, 639, 640, 638, 352,
	348, 227, 833, 125, 343, 120, 310, 619, 441, 447,
	440, 132, 607, 353, 349, 606, 435, 299, 344, 449,
	311, 228, 438, 298, 229, 133, 426, 600, 585, 453,
	455, 599, 227, 240, 584, 432, 119, 571, 454, 456,
	232, 570, 301, 441, 1022, 440, 159, 469, 441, 970,
	440, 464, 130, 458, 728, 578, 495, 477, 293, 462,
	499, 346, 483, 292, 507, 470, 471, 1057, 286, 280,
	831, 480, 228, 253, 252, 229, 119, 4, 1074, 428,
	429, 1055, 463, 634, 564, 1020, 988, 636, 635, 874,
	869, 232, 507, 866, 864, 488, 476, 191, 847, 524,
	817, 482, 1041, 431, 491, 429, 428, 428, 741, 429,
	6, 674, 125, 125, 120, 120, 601, 138, 5, 644,
	645, 646, 637, 639, 640, 638, 597, 119, 421, 419,
	125, 533, 120, 305, 935, 556, 176, 175, 474, 227,
	860, 859, 537, 555, 815, 806, 704, 689, 38, 663,
	567, 553, 562, 523, 563, 531, 568, 125, 532, 120,
	387, 561, 697, 441, 441, 440, 440, 294, 181, 182,
	174, 177, 179, 180, 178, 287, 277, 477, 483, 414,
	274, 228, 228, 273, 229, 229, 249, 591, 221, 586,
	194, 441, 193, 440, 141, 121, 441, 986, 440, 228,
	232, 232, 229, 956, 307, 590, 306, 1061, 381, 1060,
	593, 103, 795, 796, 331, 134, 476, 482, 232, 1030,
	795, 796, 1029, 879, 1076, 1019, 267, 473, 38, 268,
	613, 696, 985, 963, 314, 485, 119, 119, 318, 612,
	922, 1048, 918, 507, 862, 232, 856, 855, 787, 692,
	662, 686, 507, 684, 119, 528, 487, 4, 610, 507,
	507, 507, 507, 507, 390, 341, 230, 230, 1027, 258,
	155, 906, 676, 579, 430, 960, 934, 629, 933, 626,
	931, 119, 820, 716, 304, 196, 427, 227, 227, 227,
	6, 264, 954, 633, 556, 678, 223, 224, 5, 715,
	861, 556, 384, 695, 695, 266, 1033, 227, 794, 718,
	271, 294, 270, 90, 714, 685, 698, 916, 917, 851,
	852, 256, 413, 661, 446, 693, 415, 124, 38, 668,
	450, 445, 418, 259, 260, 460, 417, 125, 441, 125,
	440, 302, 804, 125, 227, 734, 227, 125, 721, 1015,
	297, 453, 438, 833, 951, 227, 269, 731, 719, 469,
	454, 469, 895, 896, 897, 894, 893, 892, 448, 262,
	469, 230, 713, 735, 459, 507, 507, 507, 507, 507,
	507, 507, 507, 507, 507, 507, 507, 507, 507, 507,
	507, 507, 507, 507, 507, 507, 507, 507, 507, 507,
	507, 507, 778, 264, 507, 230, 737, 616, 738, 319,
	560, 124, 557, 281, 285, 558, 125, 742, 557, 315,
	61, 558, 625, 125, 631, 125, 790, 628, 667, 507,
	556, 801, 501, 230, 394, 258, 498, 227, 494, 792,
	779, 781, 507, 127, 128, 556, 816, 791, 123, 207,
	814, 320, 805, 53, 556, 822, 258, 206, 1067, 1031,
	876, 430, 718, 227, 44, 819, 258, 797, 809, 799,
	784, 283, 230, 807, 258, 709, 710, 294, 413, 800,
	294, 827, 835, 238, 703, 294, 284, 821, 131, 294,
	1032, 294, 812, 548, 557, 131, 613, 558, 460, 259,
	260, 836, 837, 230, 294, 612, 527, 1073, 225, 233,
	1039, 843, 785, 258, 1023, 730, 38, 507, 430, 461,
	259, 260, 162, 507, 507, 998, 993, 258, 973, 284,
	259, 260, 282, 936, 535, 517, 258, 1052, 259, 260,
	1046, 255, 863, 795, 796, 227, 1004, 44, 974, 744,
	745, 943, 125, 746, 747, 811, 749, 870, 722, 556,
	695, 748, 632, 517, 630, 556, 798, 795, 796, 627,
	576, 550, 867, 898, 500, 472, 391, 259, 260, 441,
	322, 440, 202, 227, 877, 903, 905, 507, 899, 201,
	880, 259, 260, 438, 573, 198, 575, 574, 469, 135,
	259, 260, 437, 115, 904, 583, 581, 582, 949, 227,
	230, 727, 507, 665, 556, 514, 950, 909, 913, 920,
	840, 914, 932, 592, 413, 923, 265, 927, 303, 622,
	38, 556, 942, 928, 621, 925, 618, 505, 925, 945,
	617, 475, 490, 295, 968, 910, 536, 392, 254, 75,
	74, 251, 248, 507, 544, 802, 947, 380, 569, 357,
	356, 355, 930, 354, 825, 505, 444, 724, 959, 723,
	902, 828, 596, 961, 946, 829, 682, 957, 964, 335,
	966, 967, 887, 955, 208, 209, 210, 211, 213, 214,
	215, 216, 217, 218, 219, 220, 212, 441, 975, 440,
	1044, 982, 903, 987, 983, 989, 1013, 990, 1042, 1012,
	38, 438, 507, 1011, 517, 1010, 1008, 507, 1007, 556,
	977, 556, 984, 517, 944, 1059, 941, 1006, 1026, 1014,
	517, 517, 517, 517, 517, 886, 885, 884, 972, 938,
	883, 882, 609, 507, 507, 708, 706, 1016, 953, 556,
	921, 1028, 958, 868, 559, 395, 40, 1014, 230, 230,
	230, 712, 999, 1034, 554, 393, 39, 1005, 552, 878,
	14, 13, 556, 1075, 1072, 1065, 264, 1045, 230, 872,
	1043, 507, 556, 1050, 1047, 1064, 1036, 1062, 1038, 965,
	873, 813, 556, 1024, 1025, 1054, 702, 808, 549, 38,
	1056, 38, 195, 382, 38, 163, 38, 38, 1063, 1069,
	530, 556, 337, 1035, 1017, 230, 505, 230, 919, 1071,
	681, 680, 140, 1077, 677, 505, 230, 38, 526, 38,
	38, 1049, 505, 505, 505, 505, 505, 139, 915, 853,
	789, 525, 850, 788, 675, 330, 517, 517, 517, 517,
	517, 517, 517, 517, 517, 517, 517, 517, 517, 517,
	517, 517, 517, 517, 517, 517, 517, 517, 517, 517,
	517, 517, 517, 10, 38, 517, 1, 289, 451, 160,
	156, 316, 312, 126, 63, 88, 572, 38, 89, 506,
	100, 73, 11, 324, 38, 99, 98, 78, 118, 512,
	517, 3, 0, 38, 0, 0, 0, 0, 230, 0,
	0, 0, 0, 517, 0, 0, 0, 38, 0, 0,
	0, 0, 0, 0, 0, 0, 504, 0, 0, 0,
	0, 0, 0, 0, 230, 0, 191, 0, 0, 0,
	0, 0, 116, 0, 0, 0, 0, 0, 505, 505,
	505, 505, 505, 505, 505, 505, 505, 505, 505, 505,
	505, 505, 505, 505, 505, 505, 505, 505, 505, 505,
	505, 505, 505, 505, 505, 176, 175, 505, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 517, 0,
	0, 0, 0, 0, 517, 517, 0, 231, 231, 649,
	647, 648, 505, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 0, 505, 230, 0, 0, 0,
	0, 0, 272, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 846, 0, 0, 634, 0, 660,
	642, 636, 635, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 230, 0, 0, 0, 517, 0,
	0, 651, 650, 641, 643, 654, 655, 652, 653, 656,
	658, 657, 659, 644, 645, 646, 637, 639, 640, 638,
	230, 0, 547, 517, 0, 30, 0, 0, 0, 0,
	505, 0, 0, 0, 0, 0, 505, 505, 0, 0,
	0, 0, 231, 0, 0, 0, 0, 0, 144, 150,
	154, 0, 0, 0, 164, 0, 0, 0, 0, 0,
	0, 0, 197, 0, 517, 0, 0, 205, 0, 0,
	0, 0, 0, 0, 272, 0, 231, 0, 222, 0,
	0, 0, 234, 235, 236, 237, 0, 0, 239, 0,
	241, 242, 243, 244, 245, 246, 247, 0, 0, 0,
	505, 0, 0, 261, 231, 0, 0, 0, 275, 276,
	0, 278, 279, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 290, 517, 0, 505, 0, 0, 517, 208,
	209, 210, 211, 213, 214, 215, 216, 217, 218, 219,
	220, 212, 0, 231, 0, 0, 0, 0, 634, 0,
	0, 642, 636, 635, 517, 517, 0, 0, 0, 0,
	0, 0, 0, 0, 239, 0, 505, 336, 0, 0,
	0, 0, 0, 0, 231, 643, 654, 655, 652, 653,
	656, 658, 657, 659, 644, 645, 646, 637, 639, 640,
	638, 0, 517, 0, 0, 0, 358, 359, 360, 361,
	362, 363, 364, 365, 366, 367, 368, 369, 370, 371,
	372, 373, 374, 375, 376, 377, 378, 0, 0, 0,
	154, 0, 0, 0, 0, 505, 0, 0, 0, 0,
	505, 0, 0, 0, 397, 399, 400, 401, 402, 403,
	404, 405, 406, 407, 408, 409, 410, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 505, 505, 0, 0,
	0, 0, 912, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 239, 0, 423, 425, 425,
	0, 231, 0, 0, 0, 433, 0, 0, 0, 0,
	0, 649, 647, 648, 505, 0, 0, 0, 0, 154,
	154, 0, 0, 457, 0, 0, 425, 0, 0, 0,
	634, 0, 425, 290, 636, 635, 0, 0, 425, 425,
	0, 0, 0, 0, 425, 481, 0, 0, 0, 634,
	486, 660, 642, 636, 635, 0, 0, 0, 654, 655,
	652, 653, 656, 658, 657, 659, 644, 645, 646, 637,
	639, 640, 638, 651, 650, 641, 643, 654, 655, 652,
	653, 656, 658, 657, 659, 644, 645, 646, 637, 639,
	640, 638, 534, 0, 0, 342, 0, 0, 666, 538,
	539, 540, 541, 542, 0, 669, 670, 671, 672, 673,
	208, 209, 210, 211, 213, 214, 215, 216, 217, 218,
	219, 220, 212, 0, 634, 0, 543, 642, 636, 635,
	0, 0, 889, 0, 0, 0, 0, 0, 890, 0,
	0, 888, 154, 0, 0, 0, 0, 0, 0, 231,
	231, 231, 654, 655, 652, 653, 656, 658, 657, 659,
	644, 645, 646, 637, 639, 640, 638, 272, 0, 231,
	208, 209, 210, 211, 213, 214, 215, 216, 217, 218,
	219, 220, 212, 0, 0, 0, 0, 0, 0, 587,
	0, 0, 895, 896, 897, 894, 893, 892, 0, 0,
	0, 889, 0, 0, 0, 0, 231, 890, 231, 0,
	888, 0, 602, 604, 937, 0, 0, 231, 0, 0,
	154, 750, 751, 752, 753, 754, 755, 756, 757, 758,
	759, 760, 761, 762, 763, 764, 765, 766, 767, 768,
	769, 770, 771, 772, 773, 774, 775, 777, 0, 0,
	666, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 895, 896, 897, 894, 893, 892, 0, 0, 0,
	0, 0, 0, 0, 634, 0, 0, 642, 636, 635,
	649, 647, 648, 881, 0, 0, 0, 0, 0, 0,
	691, 0, 0, 0, 0, 0, 0, 0, 0, 231,
	641, 643, 654, 655, 652, 653, 656, 658, 657, 659,
	644, 645, 646, 637, 639, 640, 638, 0, 634, 844,
	660, 642, 636, 635, 726, 231, 170, 169, 191, 0,
	425, 732, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 154, 651, 650, 641, 643, 654, 655, 652, 653,
	656, 658, 657, 659, 644, 645, 646, 637, 639, 640,
	638, 743, 0, 845, 0, 192, 172, 176, 175, 848,
	849, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 0, 231, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 634, 0, 0, 642, 636, 635, 336, 793, 0,
	0, 0, 0, 911, 0, 0, 0, 0, 168, 170,
	169, 191, 0, 0, 0, 231, 650, 641, 643, 654,
	655, 652, 653, 656, 658, 657, 659, 644, 645, 646,
	637, 639, 640, 638, 0, 0, 826, 0, 0, 0,
	0, 231, 0, 0, 425, 425, 0, 834, 192, 172,
	176, 175, 841, 0, 0, 0, 154, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 952,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 0,
	0, 0, 0, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 857, 20, 0, 32, 0, 33, 0, 865, 21,
	0, 0, 0, 22, 23, 37, 44, 15, 24, 35,
	0, 0, 36, 9, 0, 26, 0, 31, 80, 81,
	7, 45, 47, 49, 0, 0, 0, 425, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 8, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 46, 48,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 624,
	34, 0, 62, 0, 96, 0, 0, 425, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 336, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 15, 24,
	35, 0, 0, 36, 9, 0, 26, 0, 31, 80,
	81, 7, 45, 47, 49, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 8,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 46,
	48, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	489, 34, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 17, 104,
	105, 12, 87, 120, 0, 29, 0, 0, 0, 94,
	28, 19, 18, 0, 20, 0, 32, 0, 33, 0,
	0, 21, 0, 0, 0, 22, 23, 37, 44, 15,
	24, 35, 0, 0, 36, 9, 0, 26, 0, 31,
	80, 81, 7, 45, 47, 49, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	8, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 27,
	46, 48, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	16, 0, 34, 0, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 0, 20, 0, 32, 0, 33,
	0, 0, 21, 0, 0, 0, 22, 23, 37, 44,
	0, 24, 35, 0, 0, 36, 0, 0, 26, 0,
	31, 80, 81, 329, 45, 47, 49, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 46, 48, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 16, 1078, 34, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	17, 104, 105, 12, 87, 120, 0, 29, 0, 0,
	0, 94, 28, 19, 18, 0, 20, 0, 32, 0,
	33, 0, 0, 21, 0, 0, 0, 22, 23, 37,
	44, 0, 24, 35, 0, 0, 36, 0, 0, 26,
	0, 31, 80, 81, 329, 45, 47, 49, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	41, 27, 46, 48, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 16, 1068, 34, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 17, 104, 105, 12, 87, 120, 0, 29, 0,
	0, 0, 94, 28, 19, 18, 0, 20, 0, 32,
	0, 33, 0, 0, 21, 0, 0, 0, 22, 23,
	37, 44, 0, 24, 35, 0, 0, 36, 0, 0,
	26, 0, 31, 80, 81, 329, 45, 47, 49, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 41, 27, 46, 48, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 16, 1058, 34, 0, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 1053,
	32, 0, 33, 0, 0, 21, 0, 0, 0, 22,
	23, 37, 44, 0, 24, 35, 0, 0, 36, 0,
	0, 26, 0, 31, 80, 81, 329, 45, 47, 49,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 46, 48, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 0, 34, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 0, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 0, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 0, 24, 35, 0, 0, 36,
	0, 0, 26, 0, 31, 80, 81, 329, 45, 47,
	49, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 46, 48, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 1018, 34, 0, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 0,
	20, 0, 32, 0, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 0, 24, 35, 0, 0,
	36, 0, 0, 26, 0, 31, 80, 81, 329, 45,
	47, 49, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 46, 48, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 995, 34, 0,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 17, 104, 105, 12, 87,
	120, 0, 29, 0, 0, 0, 94, 28, 19, 18,
	0, 20, 0, 32, 0, 33, 0, 0, 21, 0,
	0, 0, 22, 23, 37, 44, 0, 24, 35, 0,
	0, 36, 0, 0, 26, 0, 31, 80, 81, 329,
	45, 47, 49, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 27, 46, 48, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 16, 994, 34,
	0, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 0, 20, 0, 32, 0, 33, 0, 0, 21,
	0, 0, 0, 22, 23, 37, 44, 0, 24, 35,
	0, 0, 36, 0, 0, 26, 0, 31, 80, 81,
	329, 45, 47, 49, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 46, 48,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 992,
	34, 0, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 991, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 0, 24,
	35, 0, 0, 36, 0, 0, 26, 0, 31, 80,
	81, 329, 45, 47, 49, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 46,
	48, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	0, 34, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 17, 104,
	105, 12, 87, 120, 0, 29, 0, 0, 0, 94,
	28, 19, 18, 0, 20, 0, 32, 0, 33, 929,
	0, 21, 0, 0, 0, 22, 23, 37, 44, 0,
	24, 35, 0, 0, 36, 0, 0, 26, 0, 31,
	80, 81, 329, 45, 47, 49, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 41, 27,
	46, 48, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	16, 0, 34, 0, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 17,
	104, 105, 12, 87, 120, 0, 29, 0, 0, 0,
	94, 28, 19, 18, 854, 20, 0, 32, 0, 33,
	0, 0, 21, 0, 0, 0, 22, 23, 37, 44,
	0, 24, 35, 0, 0, 36, 0, 0, 26, 0,
	31, 80, 81, 329, 45, 47, 49, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	27, 46, 48, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 16, 0, 34, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	17, 104, 105, 12, 87, 120, 0, 29, 0, 0,
	0, 94, 28, 19, 18, 0, 20, 0, 32, 0,
	33, 0, 0, 21, 0, 0, 0, 22, 23, 37,
	44, 0, 24, 35, 0, 0, 36, 0, 0, 26,
	0, 31, 80, 81, 329, 45, 47, 49, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	41, 27, 46, 48, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 16, 551, 34, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 17, 104, 105, 12, 87, 120, 0, 29, 0,
	0, 0, 94, 28, 19, 18, 0, 20, 0, 32,
	0, 33, 0, 0, 21, 0, 0, 0, 22, 23,
	37, 44, 0, 24, 35, 0, 0, 36, 0, 0,
	26, 0, 31, 80, 81, 329, 45, 47, 49, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 41, 27, 46, 48, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 16, 325, 34, 0, 62, 0, 96,
	0, 0, 0, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 17, 104, 105, 12, 87, 120, 0, 29,
	0, 0, 0, 94, 28, 19, 18, 0, 20, 0,
	32, 0, 33, 0, 0, 21, 0, 0, 0, 22,
	23, 37, 44, 0, 24, 35, 0, 0, 36, 0,
	0, 26, 0, 31, 80, 81, 329, 45, 47, 49,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 41, 27, 46, 48, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 16, 0, 34, 0, 62, 0,
	96, 0, 0, 0, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 17, 104, 105, 12, 87, 120, 0,
	29, 0, 0, 0, 94, 28, 19, 18, 0, 20,
	0, 32, 0, 33, 0, 0, 21, 0, 0, 0,
	22, 23, 37, 44, 0, 24, 35, 0, 0, 36,
	0, 0, 26, 0, 31, 80, 81, 0, 0, 0,
	0, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 0, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 27, 0, 0, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 16, 0, 34, 1037, 62,
	0, 96, 0, 0, 0, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 17, 104, 105, 12, 87, 120,
	0, 29, 0, 0, 0, 94, 28, 19, 18, 0,
	20, 0, 32, 0, 33, 0, 0, 21, 0, 0,
	0, 22, 23, 37, 44, 0, 24, 35, 0, 0,
	36, 0, 0, 26, 0, 31, 80, 81, 0, 0,
	0, 0, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 41, 27, 0, 0, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 16, 0, 34, 926,
	62, 0, 96, 0, 0, 0, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 17, 104, 105, 12, 87,
	120, 0, 29, 0, 0, 0, 94, 28, 19, 18,
	0, 20, 0, 32, 0, 33, 0, 0, 21, 0,
	0, 0, 22, 23, 37, 44, 0, 24, 35, 0,
	0, 36, 0, 0, 26, 0, 31, 80, 81, 0,
	0, 0, 0, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 41, 27, 0, 0, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 16, 0, 34,
	810, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 17, 104, 105, 12,
	87, 120, 0, 29, 0, 0, 0, 94, 28, 19,
	18, 0, 20, 0, 32, 0, 33, 0, 0, 21,
	0, 0, 0, 22, 23, 37, 44, 0, 24, 35,
	0, 0, 36, 0, 0, 26, 0, 31, 80, 81,
	0, 0, 0, 0, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 41, 27, 0, 0,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 16, 0,
	34, 679, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 17, 104, 105,
	12, 87, 120, 0, 29, 0, 0, 0, 94, 28,
	19, 18, 0, 20, 0, 32, 0, 33, 0, 0,
	21, 0, 0, 0, 22, 23, 37, 44, 0, 24,
	35, 0, 0, 36, 0, 0, 26, 0, 31, 80,
	81, 0, 0, 0, 0, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 191, 0,
	0, 79, 52, 0, 0, 0, 77, 41, 27, 0,
	0, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 16,
	0, 34, 0, 62, 0, 96, 172, 176, 175, 57,
	56, 58, 59, 72, 119, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 0, 0, 839, 0,
	0, 0, 0, 0, 0, 192, 172, 176, 175, 649,
	647, 648, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 783, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 786, 634, 0, 660,
	642, 636, 635, 649, 647, 648, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 736, 0,
	0, 651, 650, 641, 643, 654, 655, 652, 653, 656,
	658, 657, 659, 644, 645, 646, 637, 639, 640, 638,
	0, 634, 0, 660, 642, 636, 635, 168, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 651, 650, 641, 643, 654,
	655, 652, 653, 656, 658, 657, 659, 644, 645, 646,
	637, 639, 640, 638, 0, 0, 0, 192, 172, 176,
	175, 0, 0, 0, 0, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 733, 0,
	0, 0, 0, 0, 0, 192, 172, 176, 175, 0,
	0, 168, 170, 169, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 690, 0, 0, 0,
	0, 192, 172, 176, 175, 0, 0, 0, 0, 168,
	170, 169, 191, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 687, 0, 0, 0, 0, 0, 0, 192,
	172, 176, 175, 0, 0, 0, 0, 168, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 166, 167, 171, 173, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	623, 0, 0, 0, 0, 0, 0, 192, 172, 176,
	175, 0, 0, 0, 0, 168, 170, 169, 191, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 620, 0,
	0, 0, 0, 0, 0, 192, 172, 176, 175, 168,
	170, 169, 191, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 166, 167, 171,
	173, 185, 186, 183, 184, 187, 188, 189, 190, 181,
	182, 174, 177, 179, 180, 178, 598, 0, 0, 192,
	172, 176, 175, 0, 0, 0, 0, 168, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 166, 167, 171, 173, 185, 186, 183, 184, 187,
	188, 189, 190, 181, 182, 174, 177, 179, 180, 178,
	577, 0, 0, 0, 0, 0, 0, 192, 172, 176,
	175, 0, 0, 0, 0, 0, 0, 0, 0, 467,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 168, 170,
	169, 191, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 192, 172,
	176, 175, 168, 170, 169, 191, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 396, 0, 0,
	166, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 420,
	0, 0, 192, 172, 176, 175, 168, 170, 169, 191,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 166, 167, 171, 173, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 0, 0, 0, 192, 172, 176, 175,
	0, 0, 0, 168, 170, 169, 191, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 166, 167,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 389, 0, 0,
	0, 0, 0, 192, 172, 176, 175, 0, 0, 0,
	168, 170, 169, 191, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 166, 167, 171, 173, 185,
	186, 183, 184, 187, 188, 189, 190, 181, 182, 174,
	177, 179, 180, 178, 340, 0, 0, 0, 0, 0,
	192, 172, 176, 175, 0, 0, 0, 168, 170, 169,
	191, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 166, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 338, 0, 0, 0, 0, 0, 192, 172, 176,
	175, 0, 0, 0, 168, 170, 169, 191, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 166,
	167, 171, 173, 185, 186, 183, 184, 187, 188, 189,
	190, 181, 182, 174, 177, 179, 180, 178, 165, 0,
	0, 0, 0, 0, 192, 172, 176, 175, 649, 647,
	648, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 166, 167, 171, 173,
	185, 186, 183, 184, 187, 188, 189, 190, 181, 182,
	174, 177, 179, 180, 178, 0, 634, 0, 660, 642,
	636, 635, 168, 170, 169, 191, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	651, 650, 641, 643, 654, 655, 652, 653, 656, 658,
	657, 659, 644, 645, 646, 637, 639, 640, 638, 0,
	0, 0, 192, 172, 176, 175, 647, 648, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 166, 167, 171, 173, 185, 186,
	183, 184, 187, 188, 189, 190, 181, 182, 174, 177,
	179, 180, 178, 634, 0, 660, 642, 636, 635, 0,
	648, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 651, 650, 641,
	643, 654, 655, 652, 653, 656, 658, 657, 659, 644,
	645, 646, 637, 639, 640, 638, 634, 0, 660, 642,
	636, 635, 169, 191, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	651, 650, 641, 643, 654, 655, 652, 653, 656, 658,
	657, 659, 644, 645, 646, 637, 639, 640, 638, 0,
	192, 172, 176, 175, 191, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 166, 167, 171, 173, 185, 186, 183, 184,
	187, 188, 189, 190, 181, 182, 174, 177, 179, 180,
	178, 192, 172, 176, 175, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 166, 167, 171, 173, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 634, 0, 660, 642, 636, 635, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 651, 650, 641, 643,
	654, 655, 652, 653, 656, 658, 657, 659, 644, 645,
	646, 637, 639, 640, 638, 634, 0, 0, 642, 636,
	635, 191, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 651,
	650, 641, 643, 654, 655, 652, 653, 656, 658, 657,
	659, 644, 645, 646, 637, 639, 640, 638, 0, 172,
	176, 175, 0, 0, 0, 0, 82, 83, 71, 0,
	104, 105, 125, 87, 120, 0, 0, 0, 0, 0,
	94, 167, 171, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 44,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 80, 81, 0, 0, 0, 0, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 615, 84, 85, 86, 191,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 41,
	147, 0, 0, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 0, 0, 0, 0, 62, 608, 96, 176, 175,
	614, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	0, 104, 105, 125, 87, 120, 0, 0, 0, 0,
	0, 94, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 0, 0, 0,
	44, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 191,
	0, 0, 148, 112, 108, 102, 615, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	145, 147, 0, 0, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 172, 176, 175,
	91, 76, 0, 0, 0, 0, 62, 0, 96, 0,
	0, 614, 57, 56, 58, 59, 72, 119, 0, 0,
	171, 173, 185, 186, 183, 184, 187, 188, 189, 190,
	181, 182, 174, 177, 179, 180, 178, 82, 83, 71,
	0, 104, 105, 125, 87, 120, 0, 0, 0, 0,
	0, 94, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	44, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 0, 0, 0, 77,
	145, 147, 0, 0, 0, 0, 0, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 0, 0, 0, 0, 62, 0, 96, 0,
	0, 842, 57, 56, 58, 59, 72, 119, 82, 83,
	71, 0, 104, 105, 125, 87, 120, 0, 0, 0,
	0, 0, 94, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 44, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 80, 81, 0, 0, 0, 0, 0,
	0, 0, 0, 51, 95, 0, 93, 109, 110, 111,
	106, 107, 0, 0, 0, 0, 0, 0, 92, 0,
	0, 0, 0, 148, 112, 108, 102, 0, 84, 85,
	86, 0, 0, 0, 0, 79, 52, 0, 0, 0,
	77, 145, 147, 0, 0, 0, 0, 0, 54, 55,
	0, 64, 65, 66, 67, 68, 69, 70, 0, 0,
	0, 91, 76, 0, 0, 0, 0, 62, 0, 96,
	0, 0, 605, 57, 56, 58, 59, 72, 119, 82,
	83, 71, 0, 104, 105, 125, 87, 120, 0, 0,
	0, 0, 0, 94, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 44, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 80, 81, 0, 0, 0, 0,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 191, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 145, 147, 0, 0, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 172,
	176, 175, 91, 76, 0, 0, 0, 0, 62, 0,
	96, 0, 0, 603, 57, 56, 58, 59, 72, 119,
	0, 0, 0, 173, 185, 186, 183, 184, 187, 188,
	189, 190, 181, 182, 174, 177, 179, 180, 178, 82,
	83, 71, 0, 104, 105, 125, 87, 120, 0, 0,
	0, 0, 0, 94, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 44, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 80, 81, 0, 0, 0, 0,
	0, 0, 0, 0, 51, 95, 0, 93, 109, 110,
	111, 106, 107, 0, 0, 0, 0, 0, 0, 92,
	0, 0, 0, 0, 148, 112, 108, 102, 0, 84,
	85, 86, 0, 0, 0, 0, 79, 52, 0, 0,
	0, 77, 145, 147, 0, 0, 0, 0, 0, 54,
	55, 0, 64, 65, 66, 67, 68, 69, 70, 0,
	0, 0, 91, 76, 0, 0, 0, 0, 62, 0,
	96, 0, 0, 291, 57, 56, 58, 59, 72, 119,
	82, 83, 71, 0, 104, 105, 125, 87, 120, 0,
	0, 0, 0, 0, 94, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 44, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 80, 81, 0, 0, 0,
	0, 0, 0, 0, 0, 51, 95, 0, 93, 109,
	110, 111, 106, 107, 0, 0, 0, 0, 0, 0,
	92, 0, 0, 0, 0, 148, 112, 108, 102, 0,
	84, 85, 86, 0, 191, 0, 0, 79, 52, 0,
	0, 0, 77, 41, 147, 0, 0, 0, 0, 0,
	54, 55, 0, 64, 65, 66, 67, 68, 69, 70,
	0, 0, 0, 91, 76, 0, 0, 0, 0, 62,
	422, 96, 172, 176, 175, 57, 56, 58, 59, 72,
	119, 82, 83, 71, 0, 104, 105, 125, 87, 120,
	0, 0, 0, 0, 0, 94, 0, 185, 186, 183,
	184, 187, 188, 189, 190, 181, 182, 174, 177, 179,
	180, 178, 0, 0, 44, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 80, 81, 0, 0,
	0, 0, 0, 0, 0, 0, 51, 95, 0, 93,
	109, 110, 111, 106, 107, 0, 0, 0, 0, 0,
	0, 92, 0, 0, 0, 0, 148, 112, 108, 102,
	0, 84, 85, 86, 0, 0, 0, 0, 79, 52,
	0, 0, 0, 77, 145, 147, 0, 0, 0, 0,
	0, 54, 55, 0, 64, 65, 66, 67, 68, 69,
	70, 0, 0, 0, 91, 76, 0, 0, 0, 0,
	62, 0, 96, 0, 0, 398, 57, 56, 58, 59,
	72, 119, 82, 83, 71, 0, 104, 105, 125, 87,
	120, 0, 0, 0, 0, 0, 94, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 44, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 80, 81, 0,
	0, 0, 0, 0, 0, 0, 0, 51, 95, 0,
	93, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 92, 0, 0, 0, 0, 148, 112, 108,
	102, 0, 84, 85, 86, 0, 0, 0, 0, 79,
	52, 0, 0, 0, 77, 145, 147, 0, 0, 0,
	0, 0, 54, 55, 0, 64, 65, 66, 67, 68,
	69, 70, 0, 0, 0, 91, 76, 0, 0, 151,
	0, 62, 0, 96, 0, 0, 0, 57, 56, 58,
	59, 72, 119, 82, 83, 71, 0, 104, 105, 125,
	87, 120, 0, 0, 0, 0, 0, 94, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 44, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 80, 81,
	0, 0, 0, 0, 0, 0, 0, 0, 51, 95,
	0, 93, 109, 110, 111, 106, 107, 0, 0, 0,
	0, 0, 0, 92, 0, 0, 0, 0, 148, 112,
	108, 102, 0, 84, 85, 86, 0, 0, 0, 0,
	79, 52, 0, 0, 0, 77, 145, 147, 0, 0,
	0, 0, 0, 54, 55, 0, 64, 65, 66, 67,
	68, 69, 70, 0, 0, 0, 91, 76, 0, 0,
	149, 0, 62, 0, 96, 0, 0, 0, 57, 56,
	58, 59, 72, 119, 82, 83, 71, 0, 104, 105,
	125, 87, 120, 0, 0, 0, 0, 0, 94, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 44, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 80,
	81, 0, 0, 0, 0, 0, 0, 0, 0, 51,
	95, 0, 93, 109, 110, 111, 106, 107, 0, 0,
	0, 0, 0, 0, 92, 0, 0, 0, 0, 148,
	112, 108, 102, 0, 84, 85, 86, 0, 0, 0,
	0, 79, 52, 0, 0, 0, 77, 145, 147, 0,
	0, 0, 0, 0, 54, 55, 0, 64, 65, 66,
	67, 68, 69, 70, 0, 0, 0, 91, 76, 0,
	0, 143, 0, 62, 0, 96, 0, 0, 0, 57,
	56, 58, 59, 72, 119, 82, 83, 71, 0, 104,
	105, 125, 87, 120, 0, 0, 0, 0, 0, 94,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 44, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	80, 81, 0, 0, 0, 0, 0, 0, 0, 0,
	51, 95, 0, 93, 109, 110, 111, 106, 107, 0,
	0, 0, 0, 0, 0, 92, 0, 0, 0, 0,
	148, 112, 108, 102, 0, 84, 85, 86, 0, 0,
	0, 0, 79, 52, 0, 0, 0, 77, 145, 147,
	0, 0, 0, 0, 0, 54, 55, 0, 64, 65,
	66, 67, 68, 69, 70, 0, 0, 0, 91, 76,
	0, 0, 0, 0, 62, 0, 96, 0, 0, 0,
	57, 56, 58, 59, 72, 119, 82, 83, 71, 0,
	104, 105, 125, 434, 120, 0, 0, 0, 0, 0,
	94, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 44,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 80, 81, 0, 0, 0, 0, 0, 0, 0,
	0, 51, 95, 0, 93, 109, 110, 111, 106, 107,
	0, 0, 0, 0, 0, 0, 92, 0, 0, 0,
	0, 148, 112, 108, 102, 0, 84, 85, 86, 0,
	0, 0, 0, 79, 52, 0, 0, 0, 77, 145,
	147, 0, 0, 0, 0, 0, 54, 55, 0, 64,
	65, 66, 67, 68, 69, 70, 0, 0, 0, 91,
	76, 0, 0, 0, 0, 62, 0, 96, 0, 0,
	0, 57, 56, 58, 59, 72, 119, 82, 83, 71,
	0, 104, 105, 125, 87, 120, 0, 0, 0, 0,
	0, 94, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	44, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 80, 81, 0, 0, 0, 0, 0, 0,
	0, 0, 51, 95, 0, 93, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 92, 0, 0,
	0, 0, 148, 112, 108, 102, 0, 84, 85, 86,
	0, 0, 0, 0, 79, 52, 104, 105, 125, 77,
	41, 147, 0, 0, 0, 0, 515, 54, 55, 0,
	64, 65, 66, 67, 68, 69, 70, 0, 0, 0,
	91, 76, 0, 0, 0, 0, 62, 0, 96, 0,
	0, 0, 57, 56, 58, 59, 72, 119, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 510, 0,
	513, 109, 110, 111, 106, 107, 0, 0, 0, 0,
	0, 0, 516, 0, 0, 0, 0, 508, 112, 108,
	509, 104, 105, 125, 0, 0, 0, 0, 0, 0,
	0, 515, 0, 0, 0, 0, 232, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	776, 522, 0, 511, 0, 0, 0, 521, 520, 518,
	519, 0, 0, 510, 0, 513, 109, 110, 111, 106,
	107, 0, 0, 0, 0, 0, 0, 516, 0, 0,
	0, 0, 508, 112, 108, 509, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 232, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 522, 0, 511, 0,
	0, 0, 521, 520, 518, 519,
}
var yyPact = [...]int{

	-1000, -1000, 2381, -1000, -1000, -1000, -1000, 332, 589, 666,
	150, -1000, 353, -1000, -1000, 849, -1000, 254, -1000, -1000,
	331, 254, 7600, 7469, 7338, 409, 172, 770, 7731, -1000,
	5737, 329, 327, -1000, -1000, 426, 7731, 845, 55, 839,
	832, 7731, -1000, -1000, -1000, -1000, 665, -1000, 657, -1000,
	1634, 325, 7731, 452, 362, 362, 7731, 7731, 7731, 7731,
	-1000, -1000, 7993, -1000, 7731, 7731, 7731, 7731, 7731, 7731,
	7731, 323, -1000, -1000, 209, 208, 784, 7731, 572, 407,
	320, 317, 7731, 7731, 313, 7731, 7731, -1000, 204, -1000,
	-1000, 775, 714, -1000, 203, 312, 6945, -1000, 198, 193,
	-1000, 489, 802, 532, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, -1000, -1000, 158, 168, -1000, 523, -1000, -1000, 425,
	-1000, 269, 345, -1000, 802, -1000, 145, 597, 587, -1000,
	682, 802, -1000, 830, -1000, -10, 4084, 352, 7993, 254,
	4870, 7731, -1000, -1000, 5690, -1000, 55, 687, 505, -1000,
	5643, -1000, 404, 1574, 5825, -1000, 143, -1000, -1000, 202,
	139, 55, -18, 138, 5825, -1000, -1000, -1000, -1000, -1000,
	7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731,
	7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731,
	7731, 407, 346, 362, 7731, 297, -1000, 5596, 403, 826,
	-1000, 639, -1000, -1000, 1634, 5549, -1000, -1000, 7207, 7731,
	7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731, 7731,
	7731, 380, -1000, -1000, -1000, -1000, -1000, 489, 504, 802,
	518, 514, -1000, -1000, -107, -107, -8, -107, 265, 5505,
	264, -107, -107, -107, -107, -107, -107, -107, -1000, 7076,
	-1000, 7731, 7731, 7731, 428, 722, 761, -1000, 238, 7862,
	362, 5994, 67, -1000, 513, -1000, 489, 502, 802, 571,
	158, 168, 512, 7731, 7731, 5825, 5825, 7731, 5825, 5825,
	7731, 517, 722, 683, -1000, 704, 7731, 6945, 185, 42,
	5461, 362, 7731, 7731, 825, 275, 489, 53, 7731, 7731,
	158, 425, 79, 275, 7731, 395, -1000, -1000, 2250, 489,
	-1000, 673, 111, -1000, 669, 802, -11, -1000, 667, 802,
	824, 663, -19, 8153, -1000, -1000, -1000, -1000, -1000, 290,
	4870, -1000, -1000, 745, 394, 41, 5825, 296, -1000, -1000,
	-1000, -1000, -1000, -1000, 172, -1000, 7731, -1000, -1000, 782,
	-1000, 8153, -1000, 7731, 7731, 7731, 7731, 7731, 5953, 6781,
	6249, 7074, 74, 74, 74, -8, -107, -8, -8, -9,
	-9, 1106, 1106, 1106, 1106, 267, 267, 267, 267, -1000,
	7731, -1000, 107, -1000, -1000, 1313, 724, 821, 3953, -1000,
	-1000, -1000, 288, -1000, 593, 615, 7731, 5994, 253, 5994,
	5994, 5994, 5994, 5994, 5994, 5994, 5994, 5994, 5994, 5994,
	5994, 94, -1000, -1000, 287, 802, 489, 67, 67, -1000,
	-1000, -1000, -1000, -107, 175, 5825, 171, -1000, -1000, -1000,
	-1000, 844, 820, 5380, 190, 413, -1000, 169, -1000, -1000,
	158, 168, -1000, 7731, 275, 162, 802, 489, -1000, 158,
	162, 76, -1000, 1634, -1000, 808, 262, 5332, 165, -1000,
	-1000, -1000, 161, 252, -1000, -1000, 6795, 6664, -1000, -1000,
	149, 146, -1000, -1000, 6252, 275, -1000, -1000, -1000, -1000,
	141, 5288, -1000, -1000, -1000, -1000, 5240, -1000, 2119, -1000,
	275, -1000, -1000, 597, 819, 658, -1000, 587, 814, 655,
	-1000, 812, 8153, -1000, 5781, -1000, -1000, 489, 501, 802,
	286, 8153, -1000, -1000, -1000, -1000, 671, 511, 8153, 8153,
	8153, 8153, 8153, 247, -1000, -1000, 4739, -1000, -1000, -1000,
	-1000, 392, 390, -1000, 5192, -25, 284, -1000, 5825, 6121,
	6369, 1838, 5994, 5144, 7731, 388, 362, 363, 363, 46,
	-39, 703, 283, 675, 576, -1000, 489, 492, 802, 424,
	593, -1000, 1634, -1000, 407, -40, 380, -1000, 489, -1000,
	-1000, -1000, 118, -1000, -1000, -1000, -1000, -1000, 7731, -1000,
	-1000, 189, 92, 275, 7731, 7731, 158, 5098, -1000, -1000,
	-1000, 489, 67, -1000, -1000, 7731, -1000, -1000, -1000, -1000,
	-1000, -1000, 5050, 362, 5825, 362, -1000, -1000, -1000, 44,
	244, -1000, -1000, 1634, 362, 7731, -1000, 275, 275, -1000,
	-1000, 275, 275, -1000, -1000, -1000, -1000, -1000, 811, -1000,
	-1000, 806, -1000, -1000, 8153, 8153, 8153, 8153, 8153, 8153,
	8153, 8153, 8153, 8153, 8153, 8153, 8153, 8153, 8153, 8153,
	8153, 8153, 8153, 8153, 8153, 8153, 8153, 8153, 8153, 8153,
	8078, 802, 489, 8153, 109, 32, 5006, 520, 720, -66,
	-66, 40, 40, 4962, 387, -1000, 4215, -1000, -1000, -1000,
	254, 7731, 7731, 448, -1000, 795, -1000, -1000, 8153, 675,
	-1000, 4868, -1000, -1000, 544, -1000, 362, 282, 544, 4608,
	805, 8153, 668, 281, 675, 236, 26, -1000, 55, -1000,
	-1000, -1000, 423, 593, 802, 489, -1000, -1, -1000, -1000,
	7731, -1000, 380, -1000, 205, -1000, 1951, 556, 7731, 7731,
	-1000, 108, 4918, -1000, -1000, -1000, 6533, -1000, -1000, -1000,
	6383, -1000, -1000, 5825, -1000, -1000, -1000, -1000, -1000, -1000,
	1793, 40, 40, -66, -66, -66, -66, 1343, 1505, 1599,
	60, 60, 40, 5911, 6037, 5868, 1749, 1896, 91, 91,
	91, 91, 218, 218, 218, 218, 8153, 1172, 489, 234,
	-1000, -1000, 8153, 8153, -1000, -1000, -1000, -1000, 486, -1000,
	3822, 386, 385, 5825, -1000, 7731, 279, 440, 383, 771,
	-1000, 230, 7731, 229, 363, -1000, -1000, 226, -1000, -1000,
	-1000, -42, -1000, -1000, -1000, -1000, 225, 676, 675, 400,
	-1000, -1, 489, 1763, 593, 275, 5994, 38, -1000, 77,
	556, 7731, -1000, 67, 411, -1000, 89, 82, -1000, -1000,
	-1000, 5825, 362, -1000, -1000, 6080, 8153, -1000, 1524, 5781,
	-1000, 254, 4870, 484, 381, -1000, -1000, -14, -1000, -1000,
	-1000, -1000, -1000, 379, 676, 4868, 4477, -1000, 380, 4477,
	3691, 8153, 421, 593, 419, 417, 271, -1000, 781, -1000,
	1694, -1000, -1000, -1000, -26, -1000, 687, 524, -1000, 801,
	593, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
	-1000, 7731, 556, -1000, 70, -1000, -1000, -1000, -1000, 557,
	-1000, 6080, 8153, -1000, -1000, 457, 254, 341, -1000, 7731,
	-1000, -1000, -1000, 416, -1000, -1000, -1000, -5, -1000, 372,
	-1000, -1000, -1000, -1000, -1000, 181, -43, -1000, 776, -1000,
	798, 55, -1000, -44, -35, -1000, 69, 556, -1000, -1000,
	-1000, 67, 5781, 4870, 371, 335, -1000, 222, -1000, 4215,
	-1000, 3560, -1000, -1000, 3429, 774, 3298, 3167, -12, -1000,
	773, 8153, -31, -48, -58, 796, 8153, -1000, 593, -1000,
	599, -1000, -1000, -1000, -1000, -1000, -1000, 4215, -1000, 4215,
	3036, 364, -1000, 221, -1000, -1000, -1000, 176, -1000, -1000,
	-1000, 762, 8153, 8153, -1000, -1000, -1000, 408, 599, -1000,
	361, 358, 674, 721, 488, -1000, -1000, 4346, -1000, -1000,
	-1000, -1000, 758, -69, -1000, -1000, 239, -1000, -1000, -1000,
	-1000, 593, 524, 790, 4215, -1000, -1000, -1000, 382, -1000,
	8153, 675, -2, -1000, 787, -1000, -1000, 2905, -1000, -1000,
	217, 593, -1000, 206, 2774, 348, -1000, -1000, -1000, -1000,
	-1000, -1000, 677, 2643, -1000, 677, -1000, 110, -1000, -1000,
	593, -1000, 755, 214, -1000, 365, -1000, 2512, -1000,
}
var yyPgo = [...]int{

	0, 1161, 52, 45, 39, 573, 1159, 1158, 7, 471,
	1202, 32, 1345, 24, 68, 62, 713, 15, 1157, 51,
	1156, 1155, 1153, 28, 1152, 46, 50, 1151, 1150, 1149,
	1148, 83, 1146, 1145, 37, 1144, 47, 0, 1143, 1142,
	1141, 6, 1140, 1139, 581, 1138, 1137, 54, 5, 1136,
	69, 61, 1133, 26, 1105, 1104, 1103, 1102, 1101, 1100,
	1099, 1098, 1097, 1088, 1084, 1082, 1081, 17, 1080, 1078,
	1074, 1073, 1072, 1070, 43, 1065, 1063, 27, 34, 23,
	1062, 1058, 1057, 1056, 1051, 1050, 8, 1049, 1048, 1047,
	1045, 1039, 1035, 3, 1034, 1033, 38, 1031, 1030, 16,
	1029, 99, 1028, 1, 1026, 1025, 1024, 1021, 29, 1016,
	1015, 1014, 33, 1013, 18, 42, 21, 1012, 1010, 1008,
	1007, 1006, 25, 1005, 191, 1002, 30, 1001, 1000, 999,
	998, 997, 996, 995, 988, 985, 984, 980, 978, 976,
	2, 975, 973, 969, 968, 966, 960, 4, 942, 939,
	936, 13, 14, 935, 931, 930, 929, 927, 680, 53,
	926, 22, 924, 923, 921, 920, 919, 918, 917, 915,
	914, 912, 911, 910, 909, 908, 907, 20, 906, 904,
	903, 902, 901, 58, 900, 19, 896, 894, 889, 888,
	886, 883, 12, 880, 877, 876, 1186, 36, 875, 873,
	35, 11, 871, 868, 867, 866, 865, 863, 862, 41,
	818,
}
var yyR1 = [...]int{

	0, 49, 36, 36, 37, 37, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 38, 38, 2,
	2, 2, 2, 39, 39, 3, 3, 3, 3, 40,
	40, 4, 4, 4, 4, 52, 52, 41, 41, 22,
	22, 22, 22, 23, 23, 24, 54, 55, 24, 58,
	59, 24, 62, 63, 24, 65, 66, 24, 68, 69,
	70, 24, 72, 24, 24, 24, 24, 24, 24, 24,
	24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
	80, 24, 24, 24, 24, 24, 83, 85, 87, 88,
	89, 83, 84, 91, 84, 90, 90, 92, 92, 94,
	95, 93, 76, 76, 96, 50, 51, 99, 99, 100,
	100, 102, 97, 106, 98, 110, 98, 104, 104, 104,
	104, 105, 105, 109, 111, 111, 107, 107, 112, 112,
	78, 78, 77, 77, 113, 77, 71, 71, 79, 79,
	82, 82, 81, 81, 73, 73, 73, 73, 115, 117,
	115, 118, 115, 116, 116, 64, 64, 56, 119, 56,
	60, 120, 60, 57, 57, 61, 61, 103, 103, 121,
	121, 122, 122, 123, 123, 123, 123, 124, 124, 124,
	125, 125, 126, 126, 126, 126, 42, 42, 25, 25,
	25, 43, 43, 43, 43, 108, 108, 129, 127, 127,
	127, 134, 127, 132, 136, 136, 137, 137, 138, 138,
	139, 139, 140, 140, 141, 144, 144, 145, 145, 143,
	142, 142, 146, 146, 135, 135, 128, 128, 133, 133,
	148, 148, 147, 147, 147, 147, 147, 147, 130, 130,
	130, 130, 131, 131, 75, 75, 67, 67, 150, 149,
	149, 151, 151, 153, 153, 155, 154, 154, 154, 156,
	157, 156, 160, 158, 13, 13, 13, 162, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 163, 13, 164, 13,
	165, 13, 166, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
	13, 13, 167, 13, 168, 169, 13, 170, 13, 13,
	13, 13, 13, 13, 13, 13, 13, 13, 172, 13,
	13, 13, 13, 13, 13, 13, 176, 13, 178, 13,
	74, 74, 74, 74, 173, 173, 173, 173, 174, 174,
	101, 177, 177, 179, 179, 179, 179, 180, 21, 181,
	21, 182, 21, 184, 21, 186, 21, 187, 21, 188,
	21, 189, 21, 9, 9, 9, 9, 86, 86, 86,
	159, 159, 191, 193, 190, 190, 194, 194, 195, 171,
	171, 171, 175, 175, 175, 161, 161, 5, 5, 5,
	5, 5, 5, 5, 5, 5, 5, 5, 5, 6,
	26, 196, 196, 196, 196, 196, 196, 196, 196, 196,
	196, 198, 198, 198, 198, 198, 198, 198, 198, 198,
	198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
	198, 198, 198, 198, 198, 198, 198, 198, 198, 198,
	198, 198, 198, 198, 33, 33, 33, 33, 27, 27,
	27, 27, 27, 27, 27, 197, 197, 200, 200, 199,
	199, 199, 199, 12, 12, 53, 53, 14, 15, 16,
	17, 17, 202, 202, 203, 152, 204, 204, 206, 205,
	201, 201, 201, 185, 185, 207, 207, 10, 20, 20,
	18, 18, 18, 19, 19, 19, 8, 8, 8, 7,
	7, 11, 11, 192, 192, 208, 208, 208, 183, 183,
	48, 48, 114, 114, 209, 210, 209, 209, 47, 47,
	46, 46, 46, 46, 46, 46, 46, 46, 44, 44,
	44, 44, 31, 31, 31, 31, 31, 31, 32, 32,
	32, 35, 35, 35, 35, 35, 35, 35, 35, 45,
	45, 34, 34, 28, 28, 29, 30,
}
var yyR2 = [...]int{

	0, 1, 2, 0, 1, 3, 1, 1, 1, 4,
	3, 5, 4, 3, 4, 4, 2, 3, 1, 1,
	3, 2, 4, 3, 1, 1, 3, 2, 4, 3,
	1, 1, 3, 2, 4, 5, 4, 2, 0, 1,
	1, 1, 4, 1, 2, 3, 0, 0, 7, 0,
	0, 10, 0, 0, 5, 0, 0, 7, 0, 0,
	0, 12, 0, 4, 2, 3, 2, 3, 2, 3,
	3, 2, 3, 3, 3, 1, 2, 5, 8, 8,
	0, 6, 1, 6, 3, 3, 0, 0, 0, 0,
	0, 13, 0, 0, 5, 1, 0, 1, 2, 0,
	0, 10, 1, 3, 1, 1, 1, 0, 1, 0,
	1, 0, 10, 0, 8, 0, 7, 1, 2, 1,
	2, 0, 2, 1, 0, 2, 0, 2, 1, 3,
	0, 2, 1, 2, 0, 5, 1, 4, 1, 4,
	1, 4, 3, 5, 3, 4, 4, 5, 0, 0,
	6, 0, 5, 1, 1, 1, 4, 0, 0, 5,
	0, 0, 6, 0, 2, 0, 3, 1, 0, 1,
	3, 4, 6, 0, 1, 1, 1, 2, 3, 3,
	1, 3, 1, 1, 2, 2, 3, 1, 1, 2,
	4, 3, 5, 1, 3, 2, 0, 0, 4, 2,
	1, 0, 9, 3, 1, 3, 1, 3, 0, 1,
	1, 2, 2, 2, 3, 1, 3, 1, 1, 3,
	4, 3, 0, 1, 1, 3, 1, 1, 0, 1,
	1, 2, 1, 1, 1, 1, 1, 1, 3, 5,
	1, 3, 5, 4, 3, 1, 0, 1, 0, 4,
	1, 2, 1, 4, 3, 0, 3, 1, 1, 0,
	0, 2, 0, 4, 6, 3, 4, 0, 7, 2,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 2, 2, 2, 2, 0, 4, 0, 4,
	0, 4, 0, 4, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 2, 2, 2,
	2, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	1, 1, 0, 5, 0, 0, 7, 0, 5, 1,
	2, 2, 2, 2, 2, 2, 2, 2, 0, 3,
	1, 1, 1, 3, 2, 1, 0, 10, 0, 11,
	2, 2, 4, 4, 4, 4, 4, 4, 4, 3,
	1, 0, 4, 3, 4, 1, 2, 0, 3, 0,
	5, 0, 4, 0, 5, 0, 5, 0, 5, 0,
	5, 0, 3, 1, 1, 3, 2, 1, 3, 2,
	1, 1, 0, 0, 6, 1, 2, 0, 2, 0,
	2, 1, 0, 1, 1, 0, 1, 1, 1, 1,
	1, 1, 1, 1, 1, 1, 1, 3, 2, 3,
	1, 1, 1, 1, 3, 2, 4, 3, 1, 1,
	1, 4, 3, 3, 3, 3, 3, 3, 2, 2,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
	5, 2, 2, 3, 1, 1, 3, 2, 1, 1,
	1, 1, 3, 3, 1, 0, 2, 0, 1, 5,
	3, 3, 1, 1, 1, 3, 3, 1, 1, 1,
	5, 1, 2, 0, 0, 4, 4, 4, 0, 2,
	1, 1, 0, 1, 2, 3, 3, 1, 4, 4,
	1, 1, 1, 1, 2, 1, 4, 4, 1, 1,
	4, 0, 1, 1, 1, 4, 4, 1, 1, 3,
	1, 2, 3, 1, 1, 0, 5, 0, 0, 2,
	5, 3, 3, 1, 6, 4, 4, 2, 2, 2,
	1, 2, 1, 4, 3, 3, 6, 3, 1, 1,
	1, 4, 4, 4, 2, 2, 4, 2, 2, 1,
	3, 1, 1, 3, 3, 3, 3,
}
var yyChk = [...]int{

	-1000, -49, -36, -1, -23, -50, -51, 51, 79, 44,
	-52, -24, 10, -97, -98, 38, 119, 7, 21, 20,
	23, 30, 34, 35, 39, -74, 46, 98, 19, 14,
	-12, 48, 25, 27, 121, 40, 43, 36, -101, -104,
	-109, 97, -14, -13, 37, 52, 99, 53, 100, 54,
	-17, 59, 92, -16, 104, 105, 130, 129, 131, 132,
	-53, -158, 123, -35, 107, 108, 109, 110, 111, 112,
	113, 6, 133, -27, -173, -174, 118, 96, -18, 91,
	49, 50, 4, 5, 84, 85, 86, 11, -33, -30,
	-5, 117, 74, 62, 18, 60, 125, -19, -20, -21,
	-28, -37, 82, -9, 8, 9, 66, 67, 81, 63,
	64, 65, 80, -8, -48, -207, -10, -185, -7, 134,
	12, 123, -37, 119, 82, 10, -38, 37, 38, -2,
	-37, 82, 121, 135, 122, 10, -41, -53, 123, -62,
	-65, 123, -53, 121, -12, 97, -101, 98, 79, 121,
	-12, 121, -13, -17, -12, 121, -42, -25, 12, 134,
	-43, -101, 12, -75, -12, 121, 149, 150, 87, 89,
	88, 151, 128, 152, 163, 130, 129, 164, 167, 165,
	166, 161, 162, 155, 156, 153, 154, 157, 158, 159,
	160, 90, 127, 123, 123, -80, 119, -12, 10, -99,
	128, 10, 10, -13, -17, -12, 52, 52, 136, 137,
	138, 139, 148, 140, 141, 142, 143, 144, 145, 146,
	147, 123, -12, 104, 105, -16, -17, -37, 79, 82,
	-9, -10, 98, -16, -12, -12, -12, -12, -158, -12,
	-74, -12, -12, -12, -12, -12, -12, -12, -171, 123,
	-53, -172, 125, 125, -175, 17, -44, -31, 12, 76,
	77, -12, 57, -159, -9, -190, -37, 79, 82, -19,
	-8, -48, -10, 123, 123, -12, -12, 123, -12, -12,
	125, -44, 17, 17, 75, -44, 125, 123, -47, -46,
	-12, 128, 125, 125, 82, -180, -37, 78, 125, 119,
	-8, 134, 78, -189, 119, 124, 121, 119, -36, -37,
	121, 135, -39, -3, -37, 82, -40, -4, -37, 82,
	29, -37, 10, 136, -22, 120, -23, -50, -51, 51,
	-54, 122, -53, -23, -67, -149, -12, -72, 121, -99,
	121, 121, 121, 121, 135, -14, 119, -17, 121, 135,
	-99, 136, 121, 135, -163, -164, -165, -166, -12, -12,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -12,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -159,
	-168, 122, -76, -96, -17, -17, -13, 123, -41, 121,
	121, 10, -176, -105, 55, -110, 58, -12, 128, -12,
	-12, -12, -12, -12, -12, -12, -12, -12, -12, -12,
	-12, -114, -209, -17, 59, 82, -37, 78, 78, 124,
	124, 124, 124, -12, -11, -12, -11, 118, -31, -31,
	17, 125, 57, -12, 11, -17, -192, -208, -185, -183,
	-8, -48, 10, 119, -160, 78, 82, -37, 57, -8,
	78, -45, -34, -17, -13, -17, -13, -12, -11, 117,
	75, 75, -11, -47, 126, -200, 135, 58, -15, -17,
	-11, -11, 10, -124, 123, -182, -183, -185, 10, 52,
	-11, -12, -183, -185, 10, -124, -12, 121, -36, 120,
	-181, -2, 121, 135, 29, -37, 121, 135, 29, -37,
	10, 29, 136, -26, -196, -5, -29, -37, 79, 82,
	60, 125, -6, 62, -198, 18, 74, -9, 131, 132,
	130, 129, 123, 123, -23, -58, -63, 21, 121, 135,
	-73, 119, 122, -25, -12, 12, -178, -26, -12, -12,
	-12, -12, -12, -12, -170, 124, 135, 29, 29, -81,
	10, 120, -102, 123, -106, -86, -37, 79, 82, -111,
	55, -13, -17, -17, 91, 124, 135, 123, -37, -167,
	126, 126, -32, 10, 13, 12, 10, 120, 125, 120,
	-201, -205, -204, -206, 125, 119, -8, -12, -161, -124,
	-185, -37, -191, -185, 124, 135, 124, 124, 124, 126,
	126, 124, -12, 128, -12, 128, 126, 126, 124, -125,
	-74, -126, -13, -17, 128, 83, -124, -184, -186, 126,
	120, -187, -188, 120, 120, -124, -3, 10, 29, -4,
	10, 29, 10, -26, 125, 130, 129, 164, 167, 165,
	166, 151, 128, 152, 161, 162, 163, 88, 89, 87,
	150, 149, 155, 156, 153, 154, 157, 159, 158, 160,
	127, 82, -37, 123, -197, -199, -196, 17, 78, -196,
	-196, -196, -196, -196, 124, -55, -41, -64, -23, 122,
	-66, -68, -150, -115, 121, -115, 121, 120, 136, 123,
	122, -12, 121, -96, -77, -17, 128, 59, -77, 124,
	135, 136, -83, 41, 123, -103, -121, -122, -123, 60,
	61, -86, -107, 56, 82, -37, 119, -112, -86, -159,
	136, -209, -210, -156, -157, 126, -12, -202, 125, 125,
	-124, -11, -12, 120, -192, -34, 58, -15, -15, 124,
	135, 124, -15, -12, -124, -124, -124, -124, 10, 10,
	-196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
	-196, -196, -196, -196, -196, -196, -196, -196, -196, -196,
	-196, -196, -196, -196, -196, -196, 122, -196, -37, -197,
	126, -200, 135, 58, 10, 52, 124, 121, -56, -59,
	-41, -53, -67, -12, 120, 32, 33, -115, 31, -115,
	-26, -103, -169, -78, 58, -17, 123, -78, -82, -23,
	122, 10, -26, -84, 42, 123, -103, 124, 135, -99,
	119, -112, -37, -108, 135, -162, -12, -114, -154, -153,
	-151, 125, -152, 57, 126, -152, -11, -11, 126, 120,
	-193, -12, 128, -126, 126, -196, 122, 124, -196, -196,
	-57, 93, 94, -60, 22, 121, 121, -12, -116, 122,
	121, 120, 121, 31, 124, -12, 124, -77, -113, 124,
	-41, 136, -91, -85, 124, -177, 44, -122, -100, 83,
	-108, 120, -127, -128, -131, -132, -133, -148, 47, 38,
	44, -147, 103, 102, 101, 98, 99, 100, -86, -161,
	124, 125, -155, -152, -11, -192, 120, 126, 126, -194,
	-15, -196, 58, -53, -23, -61, 93, 94, 121, -69,
	-116, -118, 121, -177, -79, -23, 122, -114, -79, 28,
	-26, 119, -86, 119, 119, 123, 12, 120, -129, 121,
	135, -101, -147, 10, -136, -86, -11, -151, 126, -203,
	-195, 57, -196, -119, 95, -53, 122, -67, -117, -41,
	119, -41, 124, 121, -41, -87, -41, -41, -179, 12,
	128, 136, -130, 12, 10, -99, 136, -137, 135, 121,
	119, 126, -201, -192, -23, 121, 122, -41, 124, -41,
	-41, 26, 120, 12, 120, 120, 124, 135, 12, -26,
	121, 135, 136, 136, 10, -26, -86, -138, -139, -140,
	-141, -142, -143, -145, -86, 10, -120, -70, 120, 121,
	124, 12, 128, 12, -26, -26, -134, 120, -140, 121,
	121, 45, 29, 78, -41, -71, -23, 122, -88, 12,
	136, 123, -144, -86, -146, -147, 10, -41, 119, -26,
	-103, 135, 10, 24, -41, 124, -86, 121, 120, -135,
	121, 119, -89, -41, -90, -92, -93, 41, 120, -93,
	123, -86, -94, 12, 124, -95, 119, -41, 120,
}
var yyDef = [...]int{

	3, -2, 1, 2, 6, 7, 8, 0, 0, 0,
	0, 43, 4, 105, 106, 0, 38, 0, 52, 55,
	0, 0, 0, 0, 0, 0, 0, 383, 0, 75,
	0, 0, 0, 80, 82, 0, 0, 0, 107, 0,
	0, 345, 483, 484, 360, 117, 0, 119, 0, 123,
	-2, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	320, 321, 0, 329, 0, 0, 0, 0, 0, 0,
	0, 399, 338, 340, 341, 342, 402, 0, 491, 0,
	0, 0, 0, 0, 0, 0, 0, 468, 469, 470,
	471, 0, 0, 474, 409, 0, 538, 510, 511, 512,
	464, -2, 0, 0, 407, 408, 410, 411, 412, 413,
	414, 415, 416, -2, 0, 515, 0, 381, 518, 530,
	519, 0, 0, 3, 0, 4, 0, 0, 0, 18,
	19, 0, 16, 0, 44, 0, 0, 46, 0, 0,
	0, 246, 62, 64, 0, 345, 107, 383, 0, 66,
	0, 68, 484, -2, 0, 71, 0, 187, 188, 0,
	0, 107, 193, 0, 245, 76, 286, 288, 290, 292,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 324, 0, 0, 0, 38, 0, 0, 346,
	108, 121, 115, -2, -2, 0, 118, 120, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 537, 269, 282, 284, 283, 489, -2, 0, 0,
	0, 0, 383, 285, 307, 308, 309, 310, 321, 0,
	0, 330, 331, 332, 333, 334, 335, 336, 337, 0,
	401, 0, 521, 521, 0, 403, 404, 550, 552, 0,
	0, 344, 0, 262, 390, 391, 384, 0, 0, 395,
	-2, 0, 0, 0, 0, 564, 565, 0, 567, 568,
	521, 0, 0, 0, 418, 0, 521, 538, 0, 477,
	543, 0, 521, 521, 0, 0, -2, 0, 521, 0,
	-2, 531, 0, 0, 0, 0, 10, 3, 0, -2,
	13, 0, 0, 24, 25, 0, 0, 30, 31, 0,
	0, 21, 0, 0, 37, 45, 39, 40, 41, 0,
	0, 49, 53, 0, 0, 247, 250, 0, 65, 346,
	67, 69, 70, 72, 0, 189, 0, 487, 73, 0,
	348, 0, 74, 0, 0, 0, 0, 0, 294, 295,
	296, 297, 298, 299, 300, 301, 302, 303, 304, 305,
	306, -2, -2, -2, -2, -2, -2, -2, -2, 319,
	0, 327, 0, 102, 104, -2, 484, 0, 0, 84,
	85, 111, 0, 113, 0, 124, 0, 265, 0, 270,
	271, 272, 273, 274, 275, 276, 277, 278, 279, 280,
	281, 0, 533, 534, 0, 0, -2, 0, 0, 322,
	485, 486, 400, 339, 0, 522, 0, 343, 551, 548,
	549, 0, 0, 0, 468, 0, -2, 523, 524, 527,
	503, 0, 528, 0, 405, 0, 0, 386, 392, 514,
	0, 0, 569, -2, -2, -2, 484, 0, 0, 472,
	417, 473, 0, 0, 359, 539, 478, 0, 547, 488,
	0, 0, 5, 368, 0, 0, 373, -2, -2, 576,
	0, 0, 377, -2, -2, 382, 0, 9, 0, 12,
	0, 17, 14, 0, 0, 27, 15, 0, 0, 33,
	20, 0, 0, 36, 420, 421, 422, -2, 0, 0,
	0, 475, 428, 429, 430, 409, 0, 0, 0, 0,
	0, 0, 0, 0, 47, 38, 0, 56, 58, 248,
	63, 148, 148, 186, 0, 191, 0, 194, 244, 287,
	289, 291, 293, 0, 0, 0, 0, 0, 0, 0,
	0, 86, 0, -2, 126, 122, 387, 0, 0, 0,
	0, -2, -2, 266, 0, 0, 537, 535, -2, -2,
	355, 354, 0, 558, 559, 560, 554, 555, 0, 557,
	493, 500, 501, 0, 521, 0, 504, 0, 263, 406,
	505, 385, 0, 506, 561, 0, 562, 563, 566, 357,
	356, 358, 541, 0, 542, 0, 508, 509, 177, 0,
	0, 180, -2, -2, 0, 0, 372, 0, 0, 516,
	517, 0, 0, 520, 11, 370, 23, 26, 0, 29,
	32, 0, 22, 35, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, -2, 475, 0, 477, 482, 0, 0, 438,
	439, 461, 462, 0, 0, 157, 50, 54, 155, 38,
	0, 246, 0, 0, 148, 0, 148, 190, 0, -2,
	325, 328, 77, 103, 130, 132, 0, 0, 130, 0,
	0, 0, 92, 0, -2, 0, 167, 169, 107, 174,
	175, 176, 0, 0, 0, 389, 196, 125, 128, 267,
	0, 532, 537, 323, 0, 553, 0, 490, 521, 521,
	499, 0, 0, 529, 393, 570, 0, 545, 546, 178,
	0, 179, 184, 185, 374, 376, 378, 380, 28, 34,
	0, 432, 433, 434, 435, 436, 437, 440, 441, 442,
	443, 444, 445, 446, 447, 448, 449, 450, -2, -2,
	-2, -2, -2, -2, -2, -2, 0, 0, -2, 0,
	427, 476, 478, 0, 419, 575, 463, 42, 163, 160,
	0, 0, 0, 249, 144, 0, 0, 0, 0, 0,
	192, 0, 0, 0, 0, 133, 134, 0, 81, 140,
	38, 0, 142, 83, 93, 87, 0, 361, 173, 109,
	196, 127, 388, 228, 0, 405, 264, 0, 261, -2,
	258, 521, 252, 0, 0, 492, 0, 0, 525, 526,
	397, 540, 0, 181, 431, 459, 0, 426, 480, 481,
	48, 0, 0, 165, 0, 57, 59, 0, 151, 153,
	154, 145, 146, 0, 361, 326, 0, 131, 537, 0,
	0, 0, 0, 0, 0, 0, 0, 170, 0, 110,
	228, 116, 195, 197, 0, 200, 0, -2, 227, 0,
	0, 230, 232, 233, 234, 235, 236, 237, 129, 268,
	536, 521, 0, 251, 0, 494, 556, 497, 496, 394,
	544, 460, 0, 158, 164, 0, 0, 0, 156, 246,
	149, 38, 147, 0, 78, 138, 38, 0, 79, 0,
	143, 38, 88, 38, 38, 0, 171, 114, 0, 199,
	0, 107, 231, 0, 0, 204, 0, 256, 254, -2,
	396, 0, 479, 0, 0, 0, 38, 0, 38, 152,
	38, 0, 135, 141, 0, 0, 0, 0, 0, 365,
	0, 0, 0, 240, 0, 0, 0, 203, 0, 206,
	208, 253, 495, 398, 159, 51, 161, 166, 60, 150,
	0, 0, 94, 0, 112, 347, 362, 0, 366, 172,
	198, 0, 0, 0, 201, 243, 205, 0, 209, 210,
	0, 0, 218, 0, 0, -2, 38, 0, 349, 139,
	89, 363, 0, 238, 241, 242, 0, 207, 211, 212,
	213, 0, 222, 0, 162, 61, 136, 38, 0, 364,
	0, -2, 214, 215, 0, -2, 219, 0, 38, 239,
	0, 0, 220, 0, 0, 0, 216, 137, 90, 202,
	224, 38, 96, 0, 91, 95, 97, 0, 225, 98,
	0, 99, 0, 0, 100, 0, 38, 0, 101,
}
var yyTok1 = [...]int{

	1, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 131, 117, 3, 134, 166, 128, 3,
	123, 124, 164, 130, 135, 129, 163, 165, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 122, 121,
	157, 136, 159, 127, 133, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 125, 3, 126, 152, 3, 118, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 119, 151, 120, 132,
}
var yyTok2 = [...]int{

	2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
	22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	32, 33, 34, 35, 36, 37, 38, 39, 40, 41,
	42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
	52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
	62, 63, 64, 65, 66, 67, 68, 69, 70, 71,
	72, 73, 74, 75, 76, 77, 78, 79, 80, 81,
	82, 83, 84, 85, 86, 87, 88, 89, 90, 91,
	92, 93, 94, 95, 96, 97, 98, 99, 100, 101,
	102, 103, 104, 105, 106, 107, 108, 109, 110, 111,
	112, 113, 114, 115, 116, 137, 138, 139, 140, 141,
	142, 143, 144, 145, 146, 147, 148, 149, 150, 153,
	154, 155, 156, 158, 160, 161, 162, 167,
}
var yyTok3 = [...]int{
	0,
}

var yyErrorMessages = [...]struct {
	state int
	token int
	msg   string
}{}

//line yaccpar:1

/*	parser for yacc output	*/

var (
	yyDebug        = 0
	yyErrorVerbose = false
)

type yyLexer interface {
	Lex(lval *yySymType) int
	Error(s string)
}

type yyParser interface {
	Parse(yyLexer) int
	Lookahead() int
}

type yyParserImpl struct {
	lval  yySymType
	stack [yyInitialStackSize]yySymType
	char  int
}

func (p *yyParserImpl) Lookahead() int {
	return p.char
}

func yyNewParser() yyParser {
	return &yyParserImpl{}
}

const yyFlag = -1000

func yyTokname(c int) string {
	if c >= 1 && c-1 < len(yyToknames) {
		if yyToknames[c-1] != "" {
			return yyToknames[c-1]
		}
	}
	return __yyfmt__.Sprintf("tok-%v", c)
}

func yyStatname(s int) string {
	if s >= 0 && s < len(yyStatenames) {
		if yyStatenames[s] != "" {
			return yyStatenames[s]
		}
	}
	return __yyfmt__.Sprintf("state-%v", s)
}

func yyErrorMessage(state, lookAhead int) string {
	const TOKSTART = 4

	if !yyErrorVerbose {
		return "syntax error"
	}

	for _, e := range yyErrorMessages {
		if e.state == state && e.token == lookAhead {
			return "syntax error: " + e.msg
		}
	}

	res := "syntax error: unexpected " + yyTokname(lookAhead)

	// To match Bison, suggest at most four expected tokens.
	expected := make([]int, 0, 4)

	// Look for shiftable tokens.
	base := yyPact[state]
	for tok := TOKSTART; tok-1 < len(yyToknames); tok++ {
		if n := base + tok; n >= 0 && n < yyLast && yyChk[yyAct[n]] == tok {
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}
	}

	if yyDef[state] == -2 {
		i := 0
		for yyExca[i] != -1 || yyExca[i+1] != state {
			i += 2
		}

		// Look for tokens that we accept or reduce.
		for i += 2; yyExca[i] >= 0; i += 2 {
			tok := yyExca[i]
			if tok < TOKSTART || yyExca[i+1] == 0 {
				continue
			}
			if len(expected) == cap(expected) {
				return res
			}
			expected = append(expected, tok)
		}

		// If the default action is to accept or reduce, give up.
		if yyExca[i+1] != 0 {
			return res
		}
	}

	for i, tok := range expected {
		if i == 0 {
			res += ", expecting "
		} else {
			res += " or "
		}
		res += yyTokname(tok)
	}
	return res
}

func yylex1(lex yyLexer, lval *yySymType) (char, token int) {
	token = 0
	char = lex.Lex(lval)
	if char <= 0 {
		token = yyTok1[0]
		goto out
	}
	if char < len(yyTok1) {
		token = yyTok1[char]
		goto out
	}
	if char >= yyPrivate {
		if char < yyPrivate+len(yyTok2) {
			token = yyTok2[char-yyPrivate]
			goto out
		}
	}
	for i := 0; i < len(yyTok3); i += 2 {
		token = yyTok3[i+0]
		if token == char {
			token = yyTok3[i+1]
			goto out
		}
	}

out:
	if token == 0 {
		token = yyTok2[1] /* unknown char */
	}
	if yyDebug >= 3 {
		__yyfmt__.Printf("lex %s(%d)\n", yyTokname(token), uint(char))
	}
	return char, token
}

func yyParse(yylex yyLexer) int {
	return yyNewParser().Parse(yylex)
}

func (yyrcvr *yyParserImpl) Parse(yylex yyLexer) int {
	var yyn int
	var yyVAL yySymType
	var yyDollar []yySymType
	_ = yyDollar // silence set and not used
	yyS := yyrcvr.stack[:]

	Nerrs := 0   /* number of errors */
	Errflag := 0 /* error recovery flag */
	yystate := 0
	yyrcvr.char = -1
	yytoken := -1 // yyrcvr.char translated into internal numbering
	defer func() {
		// Make sure we report no lookahead when not parsing.
		yystate = -1
		yyrcvr.char = -1
		yytoken = -1
	}()
	yyp := -1
	goto yystack

ret0:
	return 0

ret1:
	return 1

yystack:
	/* put a state and value onto the stack */
	if yyDebug >= 4 {
		__yyfmt__.Printf("char %v in %v\n", yyTokname(yytoken), yyStatname(yystate))
	}

	yyp++
	if yyp >= len(yyS) {
		nyys := make([]yySymType, len(yyS)*2)
		copy(nyys, yyS)
		yyS = nyys
	}
	yyS[yyp] = yyVAL
	yyS[yyp].yys = yystate

yynewstate:
	yyn = yyPact[yystate]
	if yyn <= yyFlag {
		goto yydefault /* simple state */
	}
	if yyrcvr.char < 0 {
		yyrcvr.char, yytoken = yylex1(yylex, &yyrcvr.lval)
	}
	yyn += yytoken
	if yyn < 0 || yyn >= yyLast {
		goto yydefault
	}
	yyn = yyAct[yyn]
	if yyChk[yyn] == yytoken { /* valid shift */
		yyrcvr.char = -1
		yytoken = -1
		yyVAL = yyrcvr.lval
		yystate = yyn
		if Errflag > 0 {
			Errflag--
		}
		goto yystack
	}

yydefault:
	/* default state action */
	yyn = yyDef[yystate]
	if yyn == -2 {
		if yyrcvr.char < 0 {
			yyrcvr.char, yytoken = yylex1(yylex, &yyrcvr.lval)
		}

		/* look through exception table */
		xi := 0
		for {
			if yyExca[xi+0] == -1 && yyExca[xi+1] == yystate {
				break
			}
			xi += 2
		}
		for xi += 2; ; xi += 2 {
			yyn = yyExca[xi+0]
			if yyn < 0 || yyn == yytoken {
				break
			}
		}
		yyn = yyExca[xi+1]
		if yyn < 0 {
			goto ret0
		}
	}
	if yyn == 0 {
		/* error ... attempt to resume parsing */
		switch Errflag {
		case 0: /* brand new error */
			yylex.Error(yyErrorMessage(yystate, yytoken))
			Nerrs++
			if yyDebug >= 1 {
				__yyfmt__.Printf("%s", yyStatname(yystate))
				__yyfmt__.Printf(" saw %s\n", yyTokname(yytoken))
			}
			fallthrough

		case 1, 2: /* incompletely recovered error ... try again */
			Errflag = 3

			/* find a state where "error" is a legal shift action */
			for yyp >= 0 {
				yyn = yyPact[yyS[yyp].yys] + yyErrCode
				if yyn >= 0 && yyn < yyLast {
					yystate = yyAct[yyn] /* simulate a shift of "error" */
					if yyChk[yystate] == yyErrCode {
						goto yystack
					}
				}

				/* the current p has no shift on "error", pop stack */
				if yyDebug >= 2 {
					__yyfmt__.Printf("error recovery pops state %d\n", yyS[yyp].yys)
				}
				yyp--
			}
			/* there is no state on the stack with an error shift ... abort */
			goto ret1

		case 3: /* no shift yet; clobber input char */
			if yyDebug >= 2 {
				__yyfmt__.Printf("error recovery discards %s\n", yyTokname(yytoken))
			}
			if yytoken == yyEofCode {
				goto ret1
			}
			yyrcvr.char = -1
			yytoken = -1
			goto yynewstate /* try again in the same state */
		}
	}

	/* reduction by production yyn */
	if yyDebug >= 2 {
		__yyfmt__.Printf("reduce %v in:\n\t%v\n", yyn, yyStatname(yystate))
	}

	yynt := yyn
	yypt := yyp
	_ = yypt // guard against "declared and not used"

	yyp -= yyR2[yyn]
	// yyp is now the index of $0. Perform the default action. Iff the
	// reduced production is ε, $1 is possibly out of range.
	if yyp+1 >= len(yyS) {
		nyys := make([]yySymType, len(yyS)*2)
		copy(nyys, yyS)
		yyS = nyys
	}
	yyVAL = yyS[yyp+1]

	/* consult goto table to find next state */
	yyn = yyR1[yyn]
	yyg := yyPgo[yyn]
	yyj := yyg + yyS[yyp].yys + 1

	if yyj >= yyLast {
		yystate = yyAct[yyg]
	} else {
		yystate = yyAct[yyj]
		if yyChk[yystate] != -yyn {
			yystate = yyAct[yyg]
		}
	}
	// dummy call; replaced with literal code
	switch yynt {

	case 1:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:213
		{
			rootnode = stmt.NewStmtList(yyDollar[1].list)
		}
	case 2:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:219
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 3:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:220
		{
			yyVAL.list = []node.Node{}
		}
	case 4:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:225
		{
			namePart := name.NewNamePart(yyDollar[1].token.Value)
			positions.AddPosition(namePart, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.list = []node.Node{namePart}
			comments.AddComments(namePart, yyDollar[1].token.Comments())
		}
	case 5:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:232
		{
			namePart := name.NewNamePart(yyDollar[3].token.Value)
			positions.AddPosition(namePart, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.list = append(yyDollar[1].list, namePart)
			comments.AddComments(namePart, yyDollar[3].token.Comments())
		}
	case 6:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:241
		{
			yyVAL.node = yyDollar[1].node
		}
	case 7:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:242
		{
			yyVAL.node = nil
		}
	case 8:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:243
		{
			yyVAL.node = nil
		}
	case 9:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:244
		{
			yyVAL.node = stmt.NewHaltCompiler()
		}
	case 10:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:246
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewNamespace(name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 11:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:256
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewNamespace(name, yyDollar[4].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[5].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 12:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:266
		{
			yyVAL.node = stmt.NewNamespace(nil, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 13:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:272
		{
			yyVAL.node = stmt.NewUseList(nil, yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 14:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:278
		{
			useType := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[2].token.Comments())

			yyVAL.node = stmt.NewUseList(useType, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 15:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:288
		{
			useType := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[2].token.Comments())

			yyVAL.node = stmt.NewUseList(useType, yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 16:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:297
		{
			yyVAL.node = nil
		}
	case 17:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:301
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 18:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:302
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 19:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:307
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 20:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:317
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 21:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:330
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 22:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:340
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 23:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:356
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 24:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:360
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 25:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:367
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 26:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:377
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 27:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:390
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 28:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:400
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 29:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:416
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 30:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:420
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 31:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:427
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 32:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:437
		{
			name := name.NewName(yyDollar[1].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			alias := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[1].list, yyDollar[3].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[1].list))
			comments.AddComments(alias, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 33:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:450
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			yyVAL.node = stmt.NewUse(nil, name, nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[2].list))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 34:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:460
		{
			name := name.NewName(yyDollar[2].list)
			positions.AddPosition(name, positionBuilder.NewNodeListPosition(yyDollar[2].list))
			alias := node.NewIdentifier(yyDollar[4].token.Value)
			positions.AddPosition(alias, positionBuilder.NewTokenPosition(yyDollar[4].token))
			yyVAL.node = stmt.NewUse(nil, name, alias)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListTokenPosition(yyDollar[2].list, yyDollar[4].token))

			comments.AddComments(name, ListGetFirstNodeComments(yyDollar[2].list))
			comments.AddComments(alias, yyDollar[4].token.Comments())
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[2].list))
		}
	case 35:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:475
		{
		}
	case 36:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:476
		{
		}
	case 37:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:480
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 38:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:481
		{
			yyVAL.list = []node.Node{}
		}
	case 39:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:486
		{
			yyVAL.node = yyDollar[1].node
		}
	case 40:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:487
		{
			yyVAL.node = nil
		}
	case 41:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:488
		{
		}
	case 42:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:489
		{
		}
	case 43:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:494
		{
			yyVAL.node = yyDollar[1].node
		}
	case 44:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:495
		{
		}
	case 45:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:499
		{
		}
	case 46:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:500
		{
		}
	case 47:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:500
		{
		}
	case 48:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:500
		{
		}
	case 49:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:501
		{
		}
	case 50:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:501
		{
		}
	case 51:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:501
		{
		}
	case 52:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:502
		{
		}
	case 53:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:502
		{
		}
	case 54:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:502
		{
		}
	case 55:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:503
		{
		}
	case 56:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:503
		{
		}
	case 57:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:503
		{
		}
	case 58:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:507
		{
		}
	case 59:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:509
		{
		}
	case 60:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:511
		{
		}
	case 61:
		yyDollar = yyS[yypt-12 : yypt+1]
		//line php5/php5.y:512
		{
		}
	case 62:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:513
		{
		}
	case 63:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:513
		{
		}
	case 64:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:514
		{
		}
	case 65:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:515
		{
		}
	case 66:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:516
		{
		}
	case 67:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:517
		{
		}
	case 68:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:518
		{
		}
	case 69:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:519
		{
		}
	case 70:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:520
		{
		}
	case 71:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:521
		{
		}
	case 72:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:522
		{
		}
	case 73:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:523
		{
		}
	case 74:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:524
		{
		}
	case 75:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:525
		{
		}
	case 76:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:526
		{
			yyVAL.node = yyDollar[1].node
		}
	case 77:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:527
		{
		}
	case 78:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:528
		{
		}
	case 79:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:529
		{
		}
	case 80:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:530
		{
		}
	case 81:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:530
		{
		}
	case 82:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:531
		{
		}
	case 83:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:532
		{
		}
	case 84:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:533
		{
		}
	case 85:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:534
		{
		}
	case 86:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:538
		{
		}
	case 87:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:539
		{
		}
	case 88:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:540
		{
		}
	case 89:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:541
		{
		}
	case 90:
		yyDollar = yyS[yypt-11 : yypt+1]
		//line php5/php5.y:542
		{
		}
	case 91:
		yyDollar = yyS[yypt-13 : yypt+1]
		//line php5/php5.y:543
		{
		}
	case 92:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:546
		{
		}
	case 93:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:547
		{
		}
	case 94:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:547
		{
		}
	case 95:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:551
		{
		}
	case 96:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:552
		{
		}
	case 97:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:556
		{
		}
	case 98:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:557
		{
		}
	case 99:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:561
		{
		}
	case 100:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:561
		{
		}
	case 101:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:561
		{
		}
	case 104:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:570
		{
		}
	case 105:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:574
		{
		}
	case 106:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:578
		{
		}
	case 107:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:582
		{
		}
	case 108:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:583
		{
		}
	case 109:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:587
		{
		}
	case 110:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:588
		{
		}
	case 111:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:592
		{
		}
	case 112:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:594
		{
		}
	case 113:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:599
		{
		}
	case 114:
		yyDollar = yyS[yypt-8 : yypt+1]
		//line php5/php5.y:603
		{
		}
	case 115:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:605
		{
		}
	case 116:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:609
		{
		}
	case 117:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:614
		{
		}
	case 118:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:615
		{
		}
	case 119:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:616
		{
		}
	case 120:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:617
		{
		}
	case 121:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:621
		{
		}
	case 122:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:622
		{
		}
	case 123:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:626
		{
		}
	case 128:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:640
		{
		}
	case 129:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:641
		{
		}
	case 130:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:645
		{
		}
	case 131:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:646
		{
		}
	case 132:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:650
		{
		}
	case 133:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:651
		{
		}
	case 134:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:652
		{
		}
	case 135:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:652
		{
		}
	case 142:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:674
		{
		}
	case 143:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:675
		{
		}
	case 144:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:680
		{
		}
	case 145:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:681
		{
		}
	case 146:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:682
		{
		}
	case 147:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:683
		{
		}
	case 148:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:688
		{
		}
	case 149:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:689
		{
		}
	case 150:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:689
		{
		}
	case 151:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:690
		{
		}
	case 152:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:690
		{
		}
	case 158:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:709
		{
		}
	case 159:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:709
		{
		}
	case 161:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:715
		{
		}
	case 162:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:715
		{
		}
	case 171:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:744
		{
		}
	case 172:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:746
		{
		}
	case 173:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:751
		{
		}
	case 174:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:752
		{
		}
	case 175:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:753
		{
		}
	case 176:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:754
		{
		}
	case 177:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:759
		{
		}
	case 178:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:760
		{
		}
	case 179:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:761
		{
		}
	case 182:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:771
		{
		}
	case 183:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:772
		{
		}
	case 184:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:773
		{
		}
	case 185:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:774
		{
		}
	case 186:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:778
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 187:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:779
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 188:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:785
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 189:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:795
		{
			yyVAL.node = expr.NewVariable(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 190:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:801
		{
			yyVAL.node = expr.NewVariable(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 191:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:811
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))

			staticVar := stmt.NewStaticVar(variable, nil)
			positions.AddPosition(staticVar, positionBuilder.NewTokenPosition(yyDollar[3].token))

			yyVAL.list = append(yyDollar[1].list, staticVar)

			comments.AddComments(identifier, yyDollar[3].token.Comments())
			comments.AddComments(variable, yyDollar[3].token.Comments())
			comments.AddComments(staticVar, yyDollar[3].token.Comments())
		}
	case 192:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:828
		{
			identifier := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[3].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[3].token))

			staticVar := stmt.NewStaticVar(variable, yyDollar[5].node)
			positions.AddPosition(staticVar, positionBuilder.NewTokenNodePosition(yyDollar[3].token, yyDollar[5].node))

			yyVAL.list = append(yyDollar[1].list, staticVar)

			comments.AddComments(identifier, yyDollar[3].token.Comments())
			comments.AddComments(variable, yyDollar[3].token.Comments())
			comments.AddComments(staticVar, yyDollar[3].token.Comments())
		}
	case 193:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:845
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))

			staticVar := stmt.NewStaticVar(variable, nil)
			positions.AddPosition(staticVar, positionBuilder.NewTokenPosition(yyDollar[1].token))

			yyVAL.list = []node.Node{staticVar}

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(staticVar, yyDollar[1].token.Comments())
		}
	case 194:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:862
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))

			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))

			staticVar := stmt.NewStaticVar(variable, yyDollar[3].node)
			positions.AddPosition(staticVar, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[3].node))

			yyVAL.list = []node.Node{staticVar}

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(staticVar, yyDollar[1].token.Comments())
		}
	case 197:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:889
		{
		}
	case 201:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:892
		{
		}
	case 202:
		yyDollar = yyS[yypt-9 : yypt+1]
		//line php5/php5.y:894
		{
		}
	case 204:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:902
		{
		}
	case 205:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:903
		{
		}
	case 214:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:927
		{
		}
	case 215:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:931
		{
		}
	case 216:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:932
		{
		}
	case 217:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:936
		{
		}
	case 218:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:937
		{
		}
	case 219:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:941
		{
		}
	case 220:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:945
		{
		}
	case 221:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:946
		{
		}
	case 222:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:950
		{
		}
	case 223:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:951
		{
		}
	case 224:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:955
		{
		}
	case 225:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:956
		{
		}
	case 226:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:960
		{
		}
	case 227:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:961
		{
		}
	case 228:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:965
		{
		}
	case 229:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:966
		{
		}
	case 230:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:970
		{
		}
	case 231:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:971
		{
		}
	case 232:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:975
		{
		}
	case 233:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:976
		{
		}
	case 234:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:977
		{
		}
	case 235:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:978
		{
		}
	case 236:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:979
		{
		}
	case 237:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:980
		{
		}
	case 238:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:984
		{
		}
	case 239:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:985
		{
		}
	case 240:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:986
		{
		}
	case 241:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:987
		{
		}
	case 242:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:991
		{
		}
	case 243:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:992
		{
		}
	case 244:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:996
		{
		}
	case 245:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:997
		{
		}
	case 246:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1002
		{
		}
	case 247:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1003
		{
		}
	case 248:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1007
		{
		}
	case 249:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1007
		{
		}
	case 250:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1008
		{
		}
	case 251:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1012
		{
		}
	case 252:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1013
		{
		}
	case 253:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1017
		{
		}
	case 254:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1018
		{
		}
	case 255:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1022
		{
		}
	case 256:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1022
		{
		}
	case 257:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1023
		{
		}
	case 258:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1024
		{
		}
	case 259:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1028
		{
		}
	case 260:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1029
		{
		}
	case 261:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1030
		{
		}
	case 262:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1034
		{
		}
	case 263:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1034
		{
		}
	case 264:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1038
		{
			yyVAL.node = nil
		}
	case 265:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1039
		{
		}
	case 266:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1040
		{
		}
	case 267:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1041
		{
		}
	case 268:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:1041
		{
		}
	case 269:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1042
		{
		}
	case 270:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1043
		{
		}
	case 271:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1044
		{
		}
	case 272:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1045
		{
		}
	case 273:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1046
		{
		}
	case 274:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1047
		{
		}
	case 275:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1048
		{
		}
	case 276:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1049
		{
		}
	case 277:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1050
		{
		}
	case 278:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1051
		{
		}
	case 279:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1052
		{
		}
	case 280:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1053
		{
		}
	case 281:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1054
		{
		}
	case 282:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1055
		{
		}
	case 283:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1056
		{
		}
	case 284:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1057
		{
		}
	case 285:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1058
		{
		}
	case 286:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1059
		{
		}
	case 287:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1059
		{
		}
	case 288:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1060
		{
		}
	case 289:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1060
		{
		}
	case 290:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1061
		{
		}
	case 291:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1061
		{
		}
	case 292:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1062
		{
		}
	case 293:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1062
		{
		}
	case 294:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1063
		{
		}
	case 295:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1064
		{
		}
	case 296:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1065
		{
		}
	case 297:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1066
		{
		}
	case 298:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1067
		{
		}
	case 299:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1068
		{
		}
	case 300:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1069
		{
		}
	case 301:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1070
		{
		}
	case 302:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1071
		{
		}
	case 303:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1072
		{
		}
	case 304:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1073
		{
		}
	case 305:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1074
		{
		}
	case 306:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1075
		{
		}
	case 307:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1076
		{
		}
	case 308:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1077
		{
		}
	case 309:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1078
		{
		}
	case 310:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1079
		{
		}
	case 311:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1080
		{
		}
	case 312:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1081
		{
		}
	case 313:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1082
		{
		}
	case 314:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1083
		{
		}
	case 315:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1084
		{
		}
	case 316:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1085
		{
		}
	case 317:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1086
		{
		}
	case 318:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1087
		{
		}
	case 319:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1088
		{
		}
	case 320:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1089
		{
		}
	case 321:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1090
		{
		}
	case 322:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1091
		{
		}
	case 323:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1091
		{
		}
	case 324:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1092
		{
		}
	case 325:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1093
		{
		}
	case 326:
		yyDollar = yyS[yypt-7 : yypt+1]
		//line php5/php5.y:1094
		{
		}
	case 327:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1095
		{
		}
	case 328:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1096
		{
		}
	case 329:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1097
		{
		}
	case 330:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1098
		{
		}
	case 331:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1099
		{
		}
	case 332:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1100
		{
		}
	case 333:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1101
		{
		}
	case 334:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1102
		{
		}
	case 335:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1103
		{
		}
	case 336:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1104
		{
		}
	case 337:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1105
		{
		}
	case 338:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1106
		{
		}
	case 339:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1106
		{
		}
	case 340:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1107
		{
		}
	case 341:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1108
		{
		}
	case 342:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1109
		{
		}
	case 343:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1110
		{
		}
	case 344:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1111
		{
		}
	case 345:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1112
		{
		}
	case 346:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1113
		{
		}
	case 347:
		yyDollar = yyS[yypt-10 : yypt+1]
		//line php5/php5.y:1115
		{
		}
	case 348:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1116
		{
		}
	case 349:
		yyDollar = yyS[yypt-11 : yypt+1]
		//line php5/php5.y:1118
		{
		}
	case 350:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1122
		{
		}
	case 351:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1123
		{
		}
	case 352:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1124
		{
		}
	case 353:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1125
		{
		}
	case 354:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1129
		{
		}
	case 355:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1130
		{
		}
	case 356:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1131
		{
		}
	case 357:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1132
		{
		}
	case 358:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1136
		{
		}
	case 359:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1137
		{
		}
	case 360:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1141
		{
		}
	case 363:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1150
		{
		}
	case 364:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1151
		{
		}
	case 365:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1152
		{
		}
	case 366:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1153
		{
		}
	case 367:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1157
		{
		}
	case 368:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1158
		{
		}
	case 369:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1159
		{
		}
	case 370:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1160
		{
		}
	case 371:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1161
		{
		}
	case 372:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1162
		{
		}
	case 373:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1163
		{
		}
	case 374:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1164
		{
		}
	case 375:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1165
		{
		}
	case 376:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1166
		{
		}
	case 377:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1167
		{
		}
	case 378:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1168
		{
		}
	case 379:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1169
		{
		}
	case 380:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1170
		{
		}
	case 381:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1171
		{
		}
	case 382:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1172
		{
		}
	case 383:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1177
		{
			yyVAL.node = node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 384:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1183
		{
			yyVAL.node = name.NewName(yyDollar[1].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeListPosition(yyDollar[1].list))
			comments.AddComments(yyVAL.node, ListGetFirstNodeComments(yyDollar[1].list))
		}
	case 385:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1189
		{
			yyVAL.node = name.NewRelative(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[3].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 386:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1195
		{
			yyVAL.node = name.NewFullyQualified(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodeListPosition(yyDollar[1].token, yyDollar[2].list))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 387:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1203
		{
		}
	case 388:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1204
		{
		}
	case 389:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1205
		{
		}
	case 390:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1211
		{
		}
	case 391:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1212
		{
		}
	case 392:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1217
		{
		}
	case 393:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1218
		{
		}
	case 394:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1219
		{
		}
	case 395:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1220
		{
		}
	case 398:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1231
		{
		}
	case 399:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1235
		{
		}
	case 400:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1236
		{
		}
	case 401:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1237
		{
		}
	case 402:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1241
		{
		}
	case 403:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1242
		{
		}
	case 404:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1243
		{
		}
	case 405:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1247
		{
		}
	case 406:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1248
		{
		}
	case 407:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1253
		{
			yyVAL.node = scalar.NewLnumber(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 408:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1259
		{
			yyVAL.node = scalar.NewDnumber(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 409:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1264
		{
			yyVAL.node = nil
		}
	case 410:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1266
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 411:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1272
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 412:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1278
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 413:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1284
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 414:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1290
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 415:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1296
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 416:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1302
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 417:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1308
		{
			yyVAL.node = scalar.NewString(yyDollar[2].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token)) /* TODO: mark as Heredoc*/
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 418:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1313
		{
			yyVAL.node = scalar.NewEncapsed(nil)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[2].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 419:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1322
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 420:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1334
		{
		}
	case 421:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1338
		{
		}
	case 422:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1339
		{
		}
	case 423:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1340
		{
		}
	case 424:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1341
		{
		}
	case 425:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1342
		{
		}
	case 426:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1343
		{
		}
	case 427:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1344
		{
		}
	case 428:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1345
		{
		}
	case 429:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1346
		{
		}
	case 430:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1347
		{
		}
	case 431:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1351
		{
		}
	case 432:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1352
		{
		}
	case 433:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1353
		{
		}
	case 434:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1354
		{
		}
	case 435:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1355
		{
		}
	case 436:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1356
		{
		}
	case 437:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1357
		{
		}
	case 438:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1358
		{
		}
	case 439:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1359
		{
		}
	case 440:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1360
		{
		}
	case 441:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1361
		{
		}
	case 442:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1362
		{
		}
	case 443:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1363
		{
		}
	case 444:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1364
		{
		}
	case 445:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1365
		{
		}
	case 446:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1366
		{
		}
	case 447:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1367
		{
		}
	case 448:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1368
		{
		}
	case 449:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1369
		{
		}
	case 450:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1370
		{
		}
	case 451:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1371
		{
		}
	case 452:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1372
		{
		}
	case 453:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1373
		{
		}
	case 454:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1374
		{
		}
	case 455:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1375
		{
		}
	case 456:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1376
		{
		}
	case 457:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1377
		{
		}
	case 458:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1378
		{
		}
	case 459:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1379
		{
		}
	case 460:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1380
		{
		}
	case 461:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1381
		{
		}
	case 462:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1382
		{
		}
	case 463:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1383
		{
		}
	case 464:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1387
		{
		}
	case 465:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1388
		{
		}
	case 466:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1389
		{
		}
	case 467:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1390
		{
		}
	case 468:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1395
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 469:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1405
		{
			yyVAL.node = yyDollar[1].node
		}
	case 470:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1407
		{
			yyVAL.node = yyDollar[1].node
		}
	case 471:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1409
		{
			yyVAL.node = yyDollar[1].node
		}
	case 472:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1411
		{
			yyVAL.node = scalar.NewEncapsed(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 473:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1417
		{
			yyVAL.node = scalar.NewEncapsed(yyDollar[2].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 474:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1423
		{
			yyVAL.node = scalar.NewMagicConstant(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 475:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1431
		{
		}
	case 476:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1432
		{
		}
	case 479:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1441
		{
		}
	case 480:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1442
		{
		}
	case 481:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1443
		{
		}
	case 482:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1444
		{
		}
	case 483:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1448
		{
			yyVAL.node = yyDollar[1].node
		}
	case 484:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1449
		{
		}
	case 485:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1453
		{
		}
	case 486:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1454
		{
		}
	case 487:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1460
		{
			yyVAL.node = yyDollar[1].node
		}
	case 488:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1468
		{
			yyVAL.node = yyDollar[1].node
		}
	case 489:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1475
		{
			yyVAL.node = yyDollar[1].node
		}
	case 490:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1482
		{
		}
	case 491:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1484
		{
			yyVAL.node = yyDollar[1].node
		}
	case 492:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1488
		{
		}
	case 493:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1489
		{
		}
	case 494:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1494
		{
		}
	case 495:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1494
		{
		}
	case 496:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1498
		{
		}
	case 497:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1499
		{
		}
	case 498:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1503
		{
		}
	case 499:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1504
		{
		}
	case 500:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1508
		{
		}
	case 501:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1509
		{
		}
	case 502:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1510
		{
		}
	case 503:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1514
		{
		}
	case 504:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1515
		{
		}
	case 505:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1519
		{
		}
	case 506:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1520
		{
		}
	case 507:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1526
		{
			yyVAL.node = yyDollar[1].node
		}
	case 508:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1532
		{
		}
	case 509:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1533
		{
		}
	case 510:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1537
		{
			yyVAL.node = yyDollar[1].node
		}
	case 511:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1538
		{
			yyVAL.node = yyDollar[1].node
		}
	case 512:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1539
		{
			yyVAL.node = yyDollar[1].node
		}
	case 513:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1544
		{
			yyVAL.node = yyDollar[1].node
		}
	case 514:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1546
		{
			yyDollar[1].simpleIndirectReference.last.SetVarName(yyDollar[2].node)

			for _, n := range yyDollar[1].simpleIndirectReference.all {
				positions[n] = positionBuilder.NewNodesPosition(n, yyDollar[2].node)
			}

			yyVAL.node = yyDollar[1].simpleIndirectReference.all[0]
		}
	case 515:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1555
		{
		}
	case 516:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1560
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 517:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1566
		{
			yyVAL.node = expr.NewArrayDimFetch(yyDollar[1].node, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[4].token))
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 518:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1571
		{
			yyVAL.node = yyDollar[1].node
		}
	case 519:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1577
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 520:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1587
		{
			yyVAL.node = expr.NewVariable(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 521:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1595
		{
			yyVAL.node = nil
		}
	case 522:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1596
		{
			yyVAL.node = yyDollar[1].node
		}
	case 523:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1601
		{
		}
	case 524:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1602
		{
		}
	case 525:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1606
		{
		}
	case 526:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1607
		{
		}
	case 527:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1608
		{
		}
	case 528:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1612
		{
		}
	case 529:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1613
		{
		}
	case 530:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1618
		{
			n := expr.NewVariable(nil)
			positions.AddPosition(n, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(n, yyDollar[1].token.Comments())

			yyVAL.simpleIndirectReference = simpleIndirectReference{[]*expr.Variable{n}, n}
		}
	case 531:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1626
		{
			n := expr.NewVariable(nil)
			positions.AddPosition(n, positionBuilder.NewTokenPosition(yyDollar[2].token))
			comments.AddComments(n, yyDollar[2].token.Comments())

			yyDollar[1].simpleIndirectReference.last.SetVarName(n)

			yyDollar[1].simpleIndirectReference.all = append(yyDollar[1].simpleIndirectReference.all, n)
			yyDollar[1].simpleIndirectReference.last = n
			yyVAL.simpleIndirectReference = yyDollar[1].simpleIndirectReference
		}
	case 534:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1646
		{
		}
	case 535:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1647
		{
		}
	case 536:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1647
		{
		}
	case 537:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1648
		{
		}
	case 538:
		yyDollar = yyS[yypt-0 : yypt+1]
		//line php5/php5.y:1654
		{
			yyVAL.list = nil
		}
	case 539:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1656
		{
			yyVAL.list = yyDollar[1].list
		}
	case 540:
		yyDollar = yyS[yypt-5 : yypt+1]
		//line php5/php5.y:1661
		{
			arrayItem := expr.NewArrayItem(yyDollar[3].node, yyDollar[5].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[3].node, yyDollar[5].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 541:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1669
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[3].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodePosition(yyDollar[3].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 542:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1677
		{
			arrayItem := expr.NewArrayItem(yyDollar[1].node, yyDollar[3].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[3].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 543:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1685
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[1].node, false)
			positions.AddPosition(arrayItem, positionBuilder.NewNodePosition(yyDollar[1].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 544:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1693
		{
			arrayItem := expr.NewArrayItem(yyDollar[3].node, yyDollar[6].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[3].node, yyDollar[6].node))
			comments.AddComments(arrayItem, comments[yyDollar[3].node])

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 545:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1701
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[4].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewTokenNodePosition(yyDollar[3].token, yyDollar[4].node))
			comments.AddComments(arrayItem, yyDollar[3].token.Comments())

			yyVAL.list = append(yyDollar[1].list, arrayItem)
		}
	case 546:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1709
		{
			arrayItem := expr.NewArrayItem(yyDollar[1].node, yyDollar[4].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewNodesPosition(yyDollar[1].node, yyDollar[4].node))
			comments.AddComments(arrayItem, comments[yyDollar[1].node])

			yyVAL.list = []node.Node{arrayItem}
		}
	case 547:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1717
		{
			arrayItem := expr.NewArrayItem(nil, yyDollar[2].node, true)
			positions.AddPosition(arrayItem, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(arrayItem, yyDollar[1].token.Comments())

			yyVAL.list = []node.Node{arrayItem}
		}
	case 548:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1728
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[2].node)
		}
	case 549:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1730
		{
			encapsed := scalar.NewEncapsedStringPart(yyDollar[2].token.Value)
			positions.AddPosition(encapsed, positionBuilder.NewTokenPosition(yyDollar[2].token))
			yyVAL.list = append(yyDollar[1].list, encapsed)
			comments.AddComments(encapsed, yyDollar[2].token.Comments())
		}
	case 550:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1737
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 551:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1739
		{
			encapsed := scalar.NewEncapsedStringPart(yyDollar[1].token.Value)
			positions.AddPosition(encapsed, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.list = []node.Node{encapsed, yyDollar[2].node}
			comments.AddComments(encapsed, yyDollar[1].token.Comments())
		}
	case 552:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1749
		{
			name := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(name, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(name)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(name, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 553:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1759
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewArrayDimFetch(variable, yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 554:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1772
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[1].token))
			fetch := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(fetch, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewPropertyFetch(variable, fetch)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(fetch, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 555:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1788
		{
			yyVAL.node = expr.NewVariable(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[3].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 556:
		yyDollar = yyS[yypt-6 : yypt+1]
		//line php5/php5.y:1794
		{
			identifier := node.NewIdentifier(yyDollar[2].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[2].token))
			variable := expr.NewVariable(identifier)
			positions.AddPosition(variable, positionBuilder.NewTokenPosition(yyDollar[2].token))
			yyVAL.node = expr.NewArrayDimFetch(variable, yyDollar[4].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[6].token))

			comments.AddComments(identifier, yyDollar[2].token.Comments())
			comments.AddComments(variable, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 557:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1808
		{
			yyVAL.node = yyDollar[2].node
		}
	case 558:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1813
		{
			yyVAL.node = scalar.NewString(yyDollar[1].token.Value)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 559:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1819
		{
			// TODO: add option to handle 64 bit integer
			if _, err := strconv.Atoi(yyDollar[1].token.Value); err == nil {
				yyVAL.node = scalar.NewLnumber(yyDollar[1].token.Value)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			} else {
				yyVAL.node = scalar.NewString(yyDollar[1].token.Value)
				positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))
			}
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 560:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1831
		{
			identifier := node.NewIdentifier(yyDollar[1].token.Value)
			positions.AddPosition(identifier, positionBuilder.NewTokenPosition(yyDollar[1].token))
			yyVAL.node = expr.NewVariable(identifier)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenPosition(yyDollar[1].token))

			comments.AddComments(identifier, yyDollar[1].token.Comments())
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 561:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1844
		{
			yyVAL.node = expr.NewIsset(yyDollar[3].list)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 562:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1850
		{
			yyVAL.node = expr.NewEmpty(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 563:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1856
		{
			yyVAL.node = expr.NewEmpty(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 564:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1862
		{
			yyVAL.node = expr.NewInclude(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 565:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1868
		{
			yyVAL.node = expr.NewIncludeOnce(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 566:
		yyDollar = yyS[yypt-4 : yypt+1]
		//line php5/php5.y:1874
		{
			yyVAL.node = expr.NewEval(yyDollar[3].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokensPosition(yyDollar[1].token, yyDollar[4].token))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 567:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1880
		{
			yyVAL.node = expr.NewRequire(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 568:
		yyDollar = yyS[yypt-2 : yypt+1]
		//line php5/php5.y:1886
		{
			yyVAL.node = expr.NewRequireOnce(yyDollar[2].node)
			positions.AddPosition(yyVAL.node, positionBuilder.NewTokenNodePosition(yyDollar[1].token, yyDollar[2].node))
			comments.AddComments(yyVAL.node, yyDollar[1].token.Comments())
		}
	case 569:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1895
		{
			yyVAL.list = []node.Node{yyDollar[1].node}
		}
	case 570:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1897
		{
			yyVAL.list = append(yyDollar[1].list, yyDollar[3].node)
		}
	case 571:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1901
		{
			yyVAL.node = yyDollar[1].node
		}
	case 572:
		yyDollar = yyS[yypt-1 : yypt+1]
		//line php5/php5.y:1902
		{
			yyVAL.node = yyDollar[1].node
		}
	case 573:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1907
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 574:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1917
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 575:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1930
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	case 576:
		yyDollar = yyS[yypt-3 : yypt+1]
		//line php5/php5.y:1943
		{
			target := node.NewIdentifier(yyDollar[3].token.Value)
			positions.AddPosition(target, positionBuilder.NewTokenPosition(yyDollar[3].token))
			yyVAL.node = expr.NewClassConstFetch(yyDollar[1].node, target)
			positions.AddPosition(yyVAL.node, positionBuilder.NewNodeTokenPosition(yyDollar[1].node, yyDollar[3].token))

			comments.AddComments(target, yyDollar[3].token.Comments())
			comments.AddComments(yyVAL.node, comments[yyDollar[1].node])
		}
	}
	goto yystack /* stack new state and value */
}
